//    Spec Last Modified Time: 2017/11/20 9:05:57
#ifndef _MCE_REG_H
#define _MCE_REG_H


#ifndef        MCE_BLOCKBASE_INF
    #define    MCE_BLOCKBASE_INF
    #define    BLOCK_MCE_VERSION 1
    #define    BLOCK_MCE_TIMESTAMP "2017/11/20 9:05:57"
    #define    MCE_BLOCK                                                  0xD // match with BlockID.h
    #define    MCE_REG_START                                              0x0 // match with BlockID.h
    #define    MCE_REG_END                                                0x18 // match with BlockID.h
    #define    MCE_REG_LIMIT                                              0x18 // match with BlockID.h
#endif

// Register offset definition
#define        Reg_Mce_Ctrl_Offset                                        0x0
#define        Reg_Mce_Rt_Offset                                          0x1
#define        Reg_Mce_Blend_Color_Offset                                 0xf
#define        Reg_Mce_Fast_Clear_Color_Offset                            0x13
#define        Reg_Mce_Global_Range_Config_Offset                         0x17

// Block constant definition
typedef enum
{
    MCE_CTRL_SRC_BITS_MODE_NORMAL            = 0,   // this is normal mode: h/w will look at source surface format
                                                    // to determine source data
    MCE_CTRL_SRC_BITS_MODE_IS_1BPP           = 1,   // this mode tells h/w that 1BPP source is enabled, so h/w will
                                                    // lookup fg_color or bg_color using each source bit. Source
                                                    // format is ignored.
    MCE_CTRL_SRC_BITS_MODE_IS_4BPP           = 2,   // this mode tells h/w that 4 bit alpha from 2D source surface 
                                                    // is enabled (Source format is ignored), so h/w will upscale
                                                    // it to alpha8=alpha4<<4|alpha4, and use it to blend:
                                                    // (fg_color*alpha8+bg_color*(~alpha8)+128)>>8. 
    MCE_CTRL_SRC_BITS_MODE_UNUSED            = 3,   // reserved
} MCE_CTRL_SRC_BITS_MODE;
typedef enum
{
    MCE_CTRL_MSAA_EN_MSAA_OFF                = 0,   // 0: msaa off
    MCE_CTRL_MSAA_EN_MSAA_ON                 = 1,   // 1: msaa on 
} MCE_CTRL_MSAA_EN;
typedef enum
{
    MCE_CTRL_MSAA_MODE_MSAA_1X               = 0,   // 0: 1 samples per pixel
    MCE_CTRL_MSAA_MODE_MSAA_2X               = 1,   // 1: 2 samples per pixel
    MCE_CTRL_MSAA_MODE_MSAA_4X               = 2,   // 2: 4 samples per pixel
    MCE_CTRL_MSAA_MODE_MSAA_8X               = 3,   // 3: 8 samples per pixel
    MCE_CTRL_MSAA_MODE_MSAA_16X              = 4,   // 4: 16 samples per pixel
} MCE_CTRL_MSAA_MODE;
typedef enum
{
    MCE_RT_MISC_DITHER_EN_DISABLE            = 0,   // 0: Disabled.
    MCE_RT_MISC_DITHER_EN_ENABLE             = 1,   // 1: Enable
} MCE_RT_MISC_DITHER_EN;
typedef enum
{
    MCE_RT_MISC_SWIZZLE_3D_EN_DISABLE        = 0,   // 0: Disable
    MCE_RT_MISC_SWIZZLE_3D_EN_ENABLE         = 1,   // 1: Enable
} MCE_RT_MISC_SWIZZLE_3D_EN;
typedef enum
{
    MCE_RT_MISC_MIPMAP_EN_DISABLE            = 0,   // 0: Disable
    MCE_RT_MISC_MIPMAP_EN_ENABLE             = 1,   // 1: Enable
} MCE_RT_MISC_MIPMAP_EN;
typedef enum
{
    MCE_RT_MISC_RESOURCE_TYPE_1D_BUFFER      = 0,   // 0000: 1D Buffer
    MCE_RT_MISC_RESOURCE_TYPE_1D_TEXTURE     = 1,   // 0001: Texture1D
    MCE_RT_MISC_RESOURCE_TYPE_2D_TEXTURE     = 2,   // 0010: Texture2D
    MCE_RT_MISC_RESOURCE_TYPE_3D_TEXTURE     = 3,   // 0011: Texture3D
    MCE_RT_MISC_RESOURCE_TYPE_CUBIC_TEXTURE  = 4,   // 0100: TextureCube
    MCE_RT_MISC_RESOURCE_TYPE_1D_TEXTURE_ARRAY= 5,  // 0101: Texture1DArray
    MCE_RT_MISC_RESOURCE_TYPE_2D_TEXTURE_ARRAY= 6,  // 0110: Texture2DArray
    MCE_RT_MISC_RESOURCE_TYPE_CUBE_TEXTURE_ARRAY= 7,// 0111: TextureCubeArray
    MCE_RT_MISC_RESOURCE_TYPE_RAW_BUFFER     = 8,   // 1000:  raw buffer.
    MCE_RT_MISC_RESOURCE_TYPE_STRUCTURED_BUFFER= 9, // 1001:  structured buffer
} MCE_RT_MISC_RESOURCE_TYPE;
typedef enum
{
    MCE_BS_BLEND_CTL_RGB_SBLEND_ZERO         = 0,   // 0x0: WGF_BLEND_ZERO = 1 (0, 0, 0, 0)
    MCE_BS_BLEND_CTL_RGB_SBLEND_ONE          = 1,   // 0x1: WGF_BLEND_ONE  = 2 (1, 1, 1, 1)
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRCCOLOR     = 2,   // 0x2: WGF_BLEND_SRCCOLOR  = 3  (oN.r, oN.g, oN.b, oN.a)
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVSRCCOLOR  = 3,   // 0x3: WGF_BLEND_INVSRCCOLOR  = 4  (1- oN.r, 1- oN.g, 1- oN.b,
                                                    // 1- oN.a)
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRCALPHA     = 4,   // 0x4: WGF_BLEND_SRCALPHA  = 5 (oN.a, oN.a, oN.a,  oN.a)
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVSRCALPHA  = 5,   // 0x5: WGF_BLEND_INVSRCALPHA = 6  (1- oN.a, 1- oN.a, 1- oN.a,
                                                    // 1- oN.a)
    MCE_BS_BLEND_CTL_RGB_SBLEND_DESTALPHA    = 6,   // 0x6: WGF_BLEND_DESTALPHA  = 7  (D.a, D.a , D.a , D.a)
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVDESTALPHA= 7,    // 0x7: WGF_BLEND_INVDESTALPHA  = 8 (1- D.a, 1-D.a, 1-D.a,
                                                    // 1-D.a )
    MCE_BS_BLEND_CTL_RGB_SBLEND_DESTCOLOR    = 8,   // 0x8: WGF_BLEND_DESTCOLOR = 9  (D.r, D.g, D.b, D.a )
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVDESTCOLOR= 9,    // 0x9: WGF_BLEND_INVDESTCOLOR = 10  (1-D.r, 1-D.g, 1-D.b,
                                                    // 1- D.a )
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRCALPHASAT  = 10,  // 0xA: WGF_BLEND_SRCALPHASAT  = 11 (f,f,f,1) f = min( oN.a,
                                                    // 1-D.a )
    MCE_BS_BLEND_CTL_RGB_SBLEND_CONSTANTCOLOR= 11,  // 0x13: (BF.RGB, BF.RGB, BF.A) for OpenGL. No
                                                    // corresponding MS value. 
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVCONSTANTCOLOR= 12,
                                                    // 0x14: (1-BF.RGB, 1- BF.RGB, 1-BF.RGB, 1- BF.A) for
                                                    // OpenGL. No corresponding MS value.
    MCE_BS_BLEND_CTL_RGB_SBLEND_CONSTANTALPHA= 13,  // 0x13: (BF.a, BF.a, BF.a, BF.a) for OpenGL. No
                                                    // corresponding MS value. 
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVCONSTANTALPHA= 14,
                                                    // 0x14: (1-BF.a, 1- BF.a, 1-BF.a, 1- BF.a) for OpenGL. No
                                                    // corresponding MS value.
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRCCONSTANTALPHA= 15,
                                                    // 0x15: (1-oN.a*BF.a, 1-oN.a*BF.a, 1-oN.a*BF.a,
                                                    // 1-oN.a*BF.a) for TextOut No corresponding MS value.
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRC1_COLOR   = 16,  // the second source for dual source blending
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVSRC1_COLOR= 17,  // the second source for dual source blending
    MCE_BS_BLEND_CTL_RGB_SBLEND_SRC1_ALPHA   = 18,  // the second source for dual source blending
    MCE_BS_BLEND_CTL_RGB_SBLEND_INVSRC1_ALPHA= 19,  // the second source for dual source blending
} MCE_BS_BLEND_CTL_RGB_SBLEND;
typedef enum
{
    MCE_BS_BLEND_CTL_RGB_BLEND_OP_ADD        = 0,   // 000: WGF_BLENDOP_ADD = 1
    MCE_BS_BLEND_CTL_RGB_BLEND_OP_SUBTRACT   = 1,   // 001: WGF_BLENDOP_SUBTRACT = 2
    MCE_BS_BLEND_CTL_RGB_BLEND_OP_REVSUBTRACT= 2,   // 010: WGF_BLENDOP_REVSUBTRACT  = 3
    MCE_BS_BLEND_CTL_RGB_BLEND_OP_MAX_OP     = 3,   // 011:MAX_OP of source and destination.
    MCE_BS_BLEND_CTL_RGB_BLEND_OP_MIN_OP     = 4,   // 100:MIN_OP of source and destination.
} MCE_BS_BLEND_CTL_RGB_BLEND_OP;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////            MCE Block (Block ID = 13) Register Definitions                            ///////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Src_Read_Alloc_En         : 1;   // need to read/allocate 2D source cacheline. 
        unsigned int Fc_St_Wr_Mask             : 8;   // Stencil write mask when it is fast clear
        unsigned int L2l_Blit_Optimization_En : 1;    // Whether enable linear to linear 2d blit optimization or
                                                      // not.
        unsigned int Src_Bits_Mode             : 2;   // for 2D copy functions (clear/image transfer/blit)
        unsigned int Color_Key_En              : 1;   // enable color key for 2D command (transparent blit), using
                                                      // BG_COLOR as key. 
        unsigned int Msaa_En                   : 1;   // MSAA enable
        unsigned int Msaa_Mode                 : 3; 
        unsigned int Reserved                  : 15; 
    } reg;
} Reg_Mce_Ctrl;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Base_Addr                 : 32;  // 2kb aligned register.
    } reg;
} Reg_Mce_Rt_Addr;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Format                    : 9;   // RT format. See Surface_format.xls for definition. 
        unsigned int Bl_Slot_Idx               : 18; 
        unsigned int Reserved                  : 5;   // reserved
    } reg;
} Reg_Mce_Rt_Fmt;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Width                     : 15;  // Width of surface in pixels.  Support 0~16K
        unsigned int Height                    : 15;  // Height of surface in pixels. Support 0~16K
        unsigned int Reserved                  : 2;   // reserved
    } reg;
} Reg_Mce_Rt_Size;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Depth_Or_Arraysize        : 12;  // depth for 3d texture, or array_size for 1d or 2d array
        unsigned int Lod                       : 4;   // mipmap level as RT
        unsigned int Range_Type                : 6; 
        unsigned int Reserved                  : 10;  // reserved
    } reg;
} Reg_Mce_Rt_Depth;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Arraysize                 : 12;  // array size of create RT view.
        unsigned int First_Array_Idx           : 11;  // first_array_slice of create RT view.
        unsigned int Reserved                  : 9;   // reserved
    } reg;
} Reg_Mce_Rt_View_Ctrl;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Rt_Enable                 : 1;   // Whether the RT is enabled or not.
        unsigned int Is_Tiling                 : 1;   // for linear<->tiling conversion
        unsigned int Rt_Write_Mask             : 4;   // RT Channel valid mask
        unsigned int Dither_En                 : 1;   // dither enable
        unsigned int D_Read_En                 : 1;   // need to read D from memory
                                                      //  even if it is write only case, the channel is not full and the
                                                      // missing channel can not occupy full bytes, we will still
                                                      // enable this bit for the RT.
        unsigned int Resolve_Write_En          : 1;   // used to determine if resolve write needed
        unsigned int Blend_Enable              : 1;   // Is the RT alpha blending enable or not.
        unsigned int Dual_Source_En            : 1;   // dual source enable or disable for current RT
        unsigned int Swizzle_3d_En             : 1;   // 3D tiling enable or not
        unsigned int Mipmap_En                 : 1;   // mipmap enable or not
        unsigned int Resource_Type             : 4; 
        unsigned int Rop                       : 5;   // ROP2/OGL Logic op operation: include all 2-operand ROP3,
                                                      // except for op between s and p. Here, the p stands for either s
                                                      // or p. 
                                                      //  </br>Examples 
                                                      //  </br>P&D        =(b'01000)
                                                      //  </br>P&(~D)   =(b'01001)
                                                      //  </br>P           =(b'00000)  //source copy
                                                      //  </br>D&(~P)      =(b'01010)
                                                      //  </br>P^D         =(b'01100)
                                                      //  </br>P|D         =(b'00100)
                                                      //  </br>~(P|D)       =(b'10100)
                                                      //  </br>~(P^D)       =(b'11100)
                                                      //  </br>~D          =(b'00001)  //special
                                                      //  </br>P|(~D)       =(b'00101)
                                                      //  </br>~P          =(b'00010)
                                                      //  </br>D|(~P)       =(b'00110)
                                                      //  </br>~P&D        =(b'11000)
                                                      //  </br>Clear =  (b11110) // special, set to 0
                                                      //  </br>Set = (b11111) //special, set to 1
                                                      //  </br>Noop = (b10000) //special, set to Dst.
        unsigned int Reserved                  : 10; 
    } reg;
} Reg_Mce_Rt_Misc;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Rgb_Sblend                : 5;   // Selects blend factor for source for RGB channels
        unsigned int Rgb_Dblend                : 5;   // Selects blend factor for destination for RGB channels,
                                                      // definition is the same as RGB_SBLEND
        unsigned int Rgb_Blend_Op              : 3;   // Blend Operation for RGB channels Select
        unsigned int Alpha_Blend_Op            : 3;   // Selects blending operation for alpha channel, values are
                                                      // same as RGB_BLEND_OP
        unsigned int Alpha_Sblend              : 5;   // Selects blend factor for source for alpha channel, values
                                                      // are same as RGB_SBLEND
        unsigned int Alpha_Dblend              : 5;   // Selects blend factor for destination for alpha channel,
                                                      // values are same as RGB_SBLEND
        unsigned int Reserved                  : 6;   // Enables alpha-blending for alpha channel
    } reg;
} Reg_Mce_Bs_Blend_Ctl;
 
typedef struct _Group_Mce_Rt
{
    Reg_Mce_Rt_Addr                  reg_Mce_Rt_Addr;
    Reg_Mce_Rt_Fmt                   reg_Mce_Rt_Fmt;
    Reg_Mce_Rt_Size                  reg_Mce_Rt_Size;
    Reg_Mce_Rt_Depth                 reg_Mce_Rt_Depth;
    Reg_Mce_Rt_View_Ctrl             reg_Mce_Rt_View_Ctrl;
    Reg_Mce_Rt_Misc                  reg_Mce_Rt_Misc;
    Reg_Mce_Bs_Blend_Ctl             reg_Mce_Bs_Blend_Ctl;
} Reg_Mce_Rt_Group;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int C_R                       : 16; 
        unsigned int C_G                       : 16; 
    } reg;
} Reg_Mce_Blend_Color_Rg;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int C_B                       : 16; 
        unsigned int C_A                       : 16; 
    } reg;
} Reg_Mce_Blend_Color_Ba;
 
typedef struct _Group_Mce_Blend_Color
{
    Reg_Mce_Blend_Color_Rg           reg_Mce_Blend_Color_Rg;
    Reg_Mce_Blend_Color_Ba           reg_Mce_Blend_Color_Ba;
} Reg_Mce_Blend_Color_Group;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Color                     : 32;  // fast clear color
    } reg;
} Reg_Mce_Fast_Clear_Color;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Global_Start              : 8;   // 4GB aligned global memory start address
        unsigned int Global_End                : 8; 
        unsigned int Reserved                  : 16; 
    } reg;
} Reg_Mce_Global_Range_Config;
 
typedef struct _Mce_regs
{
    Reg_Mce_Ctrl                     reg_Mce_Ctrl;
    Reg_Mce_Rt_Group                 reg_Mce_Rt[2];
    Reg_Mce_Blend_Color_Group        reg_Mce_Blend_Color[2];
    Reg_Mce_Fast_Clear_Color         reg_Mce_Fast_Clear_Color[4];
    Reg_Mce_Global_Range_Config      reg_Mce_Global_Range_Config;
} Mce_regs;

#endif
