//    Spec Last Modified Time: 2017/8/17 15:52:06
#ifndef _MMU_REGISTERS_H
#define _MMU_REGISTERS_H


#ifndef        MMU_BLOCKBASE_INF
    #define    MMU_BLOCKBASE_INF
    #define    BLOCK_MMU_VERSION 1
    #define    BLOCK_MMU_TIMESTAMP "2017/8/17 15:52:06"
    #define    MMU_BLOCK                                                  0x12 // match with BlockID.h
    #define    MMU_REG_START                                              0x0 // match with BlockID.h
    #define    MMU_REG_END                                                0x1000 // match with BlockID.h
    #define    MMU_REG_LIMIT                                              0x1000 // match with BlockID.h
#endif

// Register offset definition
#define        Reg_Mmu_Ttbr_Offset                                        0x0

// Block constant definition

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////            MMU Block (Block ID = 18) Register Definitions                            ///////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Valid                     : 1; 
        unsigned int Ns                        : 1; 
        unsigned int Snoop                     : 1; 
        unsigned int Segment                   : 1; 
        unsigned int Addr                      : 24; 
        unsigned int Reserved                  : 4; 
    } reg;
} Reg_Ttbr;
 
typedef struct _Group_Mmu_Ttbr
{
    Reg_Ttbr                         reg_Ttbr;
} Reg_Mmu_Ttbr_Group;
 
typedef struct _Mmu_regs
{
    Reg_Mmu_Ttbr_Group               reg_Mmu_Ttbr[4096];
} Mmu_regs;

#endif
