#ifndef __PERF_EVENT_H__
#define __PERF_EVENT_H__

#include "zx_def.h"

extern int perf_event_init(adapter_t *adapter);
extern int perf_event_deinit(adapter_t *adapter);
extern int perf_event_begin(adapter_t *adapter, zx_begin_perf_event_t *begin);
extern int perf_event_end(adapter_t *adapter, zx_end_perf_event_t *end);
extern int perf_event_add_event(adapter_t *adapter, zx_perf_event_t *perf_event);
extern int perf_event_get_event(adapter_t *adapter, zx_get_perf_event_t *get_perf_event);
extern int perf_event_get_status(adapter_t *adapter, zx_perf_status_t *get_status);
extern int perf_event_add_isr_event(adapter_t *adapter, zx_perf_event_t *perf_event);
extern int perf_event_get_isr_event(adapter_t *adapter, zx_get_perf_event_t *get_perf_event);

extern int perf_event_begin_miu_dump(adapter_t *adapter, zx_begin_miu_dump_perf_event_t *miu_begin);
extern int perf_event_end_miu_dump(adapter_t *adapter, zx_end_miu_dump_perf_event_t *miu_end);
extern int perf_event_set_miu_reg_list(adapter_t *adapter, zx_miu_reg_list_perf_event_t *miu_reg_list);
extern int perf_event_add_miu_event(adapter_t *adapter, unsigned int gpu_context, unsigned long long task_id, unsigned long long fence_id, int task_end);
extern int perf_event_get_miu_event(adapter_t *adapter, zx_get_miu_dump_perf_event_t *get_miu_perf_event);
extern int perf_event_util_miu_counter_dump(adapter_t *adapter, zx_miu_list_item_t *miu_list, unsigned int list_length, int fore_read);
extern int perf_event_direct_get_miu_dump_event(adapter_t *adapter, zx_direct_get_miu_dump_perf_event_t *current_miu);

#endif

