#ifndef __RING_BUFFER_H
#define __RING_BUFFER_H


typedef struct ring_buffer ring_buffer_t;

typedef int (*ring_func_t)(ring_buffer_t *ring, int skip_cnt, void *private_data);


struct ring_buffer
{
    unsigned int head; // buffer begin used offset 
    unsigned int tail; // buffer used end offset
    unsigned int size;
    unsigned int left_size;
    unsigned int reserved_size; // reserved space from buffer begin.

    ring_func_t  wrap;
    void         *private_data;
};
 

extern int ring_buffer_init(ring_buffer_t *ring, int size, int reserved_size, ring_func_t wrap, void *private_data);
extern int ring_buffer_get_space(ring_buffer_t *ring, int requested_size);

#endif


