/*
 * Copyright (c) 2018 Shanghai Zhaoxin Semiconductor Co., Ltd.
 * All Rights Reserved.
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Shanghai Zhaoxin Semiconductor Co., Ltd.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Shanghai Zhaoxin Semiconductor Co., Ltd.
 *
 * The copyright of the source code is protected by the copyright laws of the People's
 * Republic of China and the related laws promulgated by the People's Republic of China
 * and the international covenant(s) ratified by the People's Republic of China.
 *
 */
#ifndef _zx_ke_interface_h_
#define _zx_ke_interface_h_

#include <stdio.h>
#include <stdlib.h>
#include "zx_def.h"
#include "zx_types.h"
#include "zx_version.h"

#ifndef EXTERN_C
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#endif

#define __STR(x) #x
#define STR(x) __STR(x)

#undef __CONCAT
#undef CONCAT
#define __CONCAT(x,y) x##y
#define CONCAT(x,y)     __CONCAT(x,y)

typedef enum _ENUM_RET
{ 
    ENUM_RET_SUCCESS = 0,
    ENUM_RET_FAILURE = 1,
    ENUM_RET_CONTINUE = 2,
    ENUM_RET_LAST,
}ENUM_RET;

#ifdef __INTERFACE_IMPLEMENT_DEFINED__
EXTERN_C int zxWaitChipIdle(int fd);
EXTERN_C int zxWaitAllocationIdle(int fd, zx_wait_allocation_idle_t *wait);

EXTERN_C int zxQueryInfo(int fd, zx_query_info_t *info);

EXTERN_C int zxCreateDevice(int fd, zx_create_device_t* create_device);

EXTERN_C int zxDestroyDevice(int fd, unsigned int device);


EXTERN_C int zxBeginPerfEvent(int fd, zx_begin_perf_event_t *begin_perf_event);

EXTERN_C int zxEndPerfEvent(int fd, zx_end_perf_event_t *end_perf_event);

EXTERN_C int zxGetPerfEvent(int fd, zx_get_perf_event_t *get_perf_event);

EXTERN_C int zxSendPerfEvent(int fd, zx_perf_event_t *perf_event);

EXTERN_C int zxGetPerfStatus(int fd, zx_perf_status_t *perf_status);

EXTERN_C int zxBeginMiuDumpPerfEvent(int fd, zx_begin_miu_dump_perf_event_t *begin_miu_perf_event);

EXTERN_C int zxEndMiuDumpPerfEvent(int fd, zx_end_miu_dump_perf_event_t *end_miu_perf_event);

EXTERN_C int zxSetMiuRegListPerfEvent(int fd, zx_miu_reg_list_perf_event_t *miu_reg_list);

EXTERN_C int zxGetMiuDumpPerfEvent(int fd, zx_get_miu_dump_perf_event_t *get_miu_dump);

EXTERN_C int zxDirectGetMiuDumpPerfEvent(int fd, zx_direct_get_miu_dump_perf_event_t *direct_get_dump);

EXTERN_C int zxDvfsSet(int fd, zx_dvfs_set_t * set);
EXTERN_C int zxQueryDvfsClamp(int fd, zx_dvfs_clamp_status_t * dvfs_clamp);


EXTERN_C int zxCreateContext(int fd,zx_create_context_t * create_context);

EXTERN_C int zxDestroyContext(int fd,zx_destroy_context_t * destroy_context);

EXTERN_C int zxRender(int fd,zx_render_t * render);

EXTERN_C int zxCreateFenceSyncObject(int fd, zx_create_fence_sync_object_t *create);

EXTERN_C int zxDestroyFenceSyncObject(int fd, zx_destroy_fence_sync_object_t *destroy);

EXTERN_C int zxWaitFenceSyncObject(int fd, zx_wait_fence_sync_object_t *wait);

EXTERN_C int zxFenceValue(int fd, zx_fence_value_t *fence);

EXTERN_C int zxWaitContextIdle(int fd, unsigned int context);

EXTERN_C int zxAddHwCtxBuf(int fd, zx_add_hw_ctx_buf_t * add);
EXTERN_C int zxRmHwCtxBuf(int fd, zx_rm_hw_ctx_buf_t * rm);
EXTERN_C int zxCIL2Misc(int fd,zx_cil2_misc_t * misc);

///////////////////////////////////////////////////////////////////////////////////
EXTERN_C int zxGemDestroyObject(int fd, unsigned int handle);
EXTERN_C int zxGemCreateAllocation(int fd, zx_create_allocation_t *create);
EXTERN_C int zxGemCreateResource(int fd, zx_create_resource_t *create);
EXTERN_C int zxGemMapGtt(int fd, zx_drm_gem_map_t *map);
EXTERN_C int zxGemUnmap(int fd);

EXTERN_C int zxGetAllocationState(int fd, zx_get_allocation_state_t *state);
EXTERN_C int zxGetPipeFromCRTC(int fd, zx_kms_get_pipe_from_crtc_t *get_pipe);
EXTERN_C int zxGemBeginCpuAccess(int fd, zx_drm_gem_begin_cpu_access_t *begin);
EXTERN_C int zxGemEndCpuAccess(int fd, zx_drm_gem_end_cpu_access_t *end);

EXTERN_C int zxDelayInitCard(int fd,zx_delay_init_card_t * delay_init_card);
#else

#define zxWaitContextIdle CONCAT(kinterface_v2,DRIVER_NAME)->WaitContextIdle
#define zxWaitChipIdle CONCAT(kinterface_v2,DRIVER_NAME)->WaitChipIdle
#define zxWaitAllocationIdle CONCAT(kinterface_v2,DRIVER_NAME)->WaitAllocationIdle
#define zxQueryInfo CONCAT(kinterface_v2,DRIVER_NAME)->QueryInfo
#define zxCreateDevice CONCAT(kinterface_v2,DRIVER_NAME)->CreateDevice
#define zxDestroyDevice CONCAT(kinterface_v2,DRIVER_NAME)->DestroyDevice
#define zxBeginPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->BeginPerfEvent
#define zxEndPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->EndPerfEvent
#define zxGetPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->GetPerfEvent
#define zxSendPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->SendPerfEvent
#define zxGetPerfStatus CONCAT(kinterface_v2,DRIVER_NAME)->GetPerfStatus
#define zxBeginMiuDumpPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->BeginMiuDumpPerfEvent
#define zxEndMiuDumpPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->EndMiuDumpPerfEvent
#define zxSetMiuRegListPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->SetMiuRegListPerfEvent
#define zxGetMiuDumpPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->GetMiuDumpPerfEvent
#define zxDirectGetMiuDumpPerfEvent CONCAT(kinterface_v2,DRIVER_NAME)->DirectGetMiuDumpPerfEvent
#define zxDvfsSet CONCAT(kinterface_v2,DRIVER_NAME)->DvfsSet
#define zxQueryDvfsClamp CONCAT(kinterface_v2,DRIVER_NAME)->QueryDvfsClamp
#define zxCreateContext CONCAT(kinterface_v2,DRIVER_NAME)->CreateContext
#define zxDestroyContext CONCAT(kinterface_v2,DRIVER_NAME)->DestroyContext
#define zxRender CONCAT(kinterface_v2,DRIVER_NAME)->Render
#define zxCreateFenceSyncObject CONCAT(kinterface_v2,DRIVER_NAME)->CreateFenceSyncObject
#define zxDestroyFenceSyncObject CONCAT(kinterface_v2,DRIVER_NAME)->DestroyFenceSyncObject
#define zxWaitFenceSyncObject CONCAT(kinterface_v2,DRIVER_NAME)->WaitFenceSyncObject
#define zxFenceValue CONCAT(kinterface_v2,DRIVER_NAME)->FenceValue
#define zxAddHwCtxBuf CONCAT(kinterface_v2,DRIVER_NAME)->AddHwCtxBuf
#define zxRmHwCtxBuf CONCAT(kinterface_v2,DRIVER_NAME)->RmHwCtxBuf
#define zxCIL2Misc CONCAT(kinterface_v2,DRIVER_NAME)->CIL2Misc
#define zxGemDestroyObject CONCAT(kinterface_v2,DRIVER_NAME)->GemDestroyObject
#define zxGemCreateAllocation CONCAT(kinterface_v2,DRIVER_NAME)->GemCreateAllocation
#define zxGemCreateResource CONCAT(kinterface_v2,DRIVER_NAME)->GemCreateResource
#define zxGemMapGtt CONCAT(kinterface_v2,DRIVER_NAME)->GemMapGtt
#define zxGemUnmap CONCAT(kinterface_v2,DRIVER_NAME)->GemUnmap
#define zxGetAllocationState CONCAT(kinterface_v2,DRIVER_NAME)->GetAllocationState
#define zxGetPipeFromCRTC CONCAT(kinterface_v2,DRIVER_NAME)->GetPipeFromCRTC
#define zxGemBeginCpuAccess CONCAT(kinterface_v2,DRIVER_NAME)->GemBeginCpuAccess
#define zxGemEndCpuAccess CONCAT(kinterface_v2,DRIVER_NAME)->GemEndCpuAccess
#define zxDelayInitCard CONCAT(kinterface_v2, DRIVER_NAME)->DelayInitCard

#endif

struct kernel_interface {
    int  (*WaitChipIdle) (int fd);
    int  (*WaitAllocationIdle) (int fd, zx_wait_allocation_idle_t *wait);
    int  (*QueryInfo) (int fd, zx_query_info_t *info);
    int  (*CreateDevice) (int fd, zx_create_device_t* create_device);
    int  (*DestroyDevice) (int fd, unsigned int device);
    int  (*BeginPerfEvent) (int fd, zx_begin_perf_event_t *begin_perf_event);
    int  (*EndPerfEvent) (int fd, zx_end_perf_event_t *end_perf_event);
    int  (*GetPerfEvent) (int fd, zx_get_perf_event_t *get_perf_event);
    int  (*SendPerfEvent) (int fd, zx_perf_event_t *perf_event);
    int  (*GetPerfStatus) (int fd, zx_perf_status_t *perf_status);
    int  (*BeginMiuDumpPerfEvent) (int fd, zx_begin_miu_dump_perf_event_t *begin_miu_perf_event);
    int  (*EndMiuDumpPerfEvent) (int fd, zx_end_miu_dump_perf_event_t *end_miu_perf_event);
    int  (*SetMiuRegListPerfEvent) (int fd, zx_miu_reg_list_perf_event_t *miu_reg_list);
    int  (*GetMiuDumpPerfEvent) (int fd, zx_get_miu_dump_perf_event_t *get_miu_dump);
    int  (*DirectGetMiuDumpPerfEvent) (int fd, zx_direct_get_miu_dump_perf_event_t *direct_get_dump);
    int  (*DvfsSet) (int fd, zx_dvfs_set_t * set);
    int  (*QueryDvfsClamp) (int fd, zx_dvfs_clamp_status_t * dvfs_clamp);	
    int  (*CreateContext) (int fd,zx_create_context_t * create_context);
    int  (*DestroyContext) (int fd,zx_destroy_context_t * destroy_context);
    int  (*Render) (int fd,zx_render_t * render);
    int  (*CreateFenceSyncObject) (int fd, zx_create_fence_sync_object_t *create);
    int  (*DestroyFenceSyncObject) (int fd, zx_destroy_fence_sync_object_t *destroy);
    int  (*WaitFenceSyncObject) (int fd, zx_wait_fence_sync_object_t *wait);
    int  (*FenceValue) (int fd, zx_fence_value_t *fence);
    int  (*WaitContextIdle) (int fd,unsigned int context);	
    int  (*AddHwCtxBuf) (int fd, zx_add_hw_ctx_buf_t * add);
    int  (*RmHwCtxBuf) (int fd, zx_rm_hw_ctx_buf_t * rm);
    int  (*CIL2Misc) (int fd,zx_cil2_misc_t * misc);
    int  (*GemDestroyObject) (int fd, unsigned int handle);
    int  (*GemCreateAllocation) (int fd, zx_create_allocation_t *create);
    int  (*GemCreateResource) (int fd, zx_create_resource_t *create);
    int  (*GemMapGtt) (int fd, zx_drm_gem_map_t *map);
    int  (*GemUnmap) (int fd);
    int  (*GetAllocationState) (int fd, zx_get_allocation_state_t *state);
    int  (*GetPipeFromCRTC) (int fd, zx_kms_get_pipe_from_crtc_t *get_pipe);
    int  (*GemBeginCpuAccess) (int fd, zx_drm_gem_begin_cpu_access_t *begin);
    int  (*GemEndCpuAccess) (int fd, zx_drm_gem_end_cpu_access_t *end);	
    int  (*DelayInitCard)(int fd,zx_delay_init_card_t * delay_init_card);
};
EXTERN_C struct kernel_interface * CONCAT(kinterface_v2,DRIVER_NAME);
#endif

