//    Spec Last Modified Time: 2020/4/2 11:06:19
#ifndef _VPP_GLOBAL_REGISTERS_H
#define _VPP_GLOBAL_REGISTERS_H


#ifndef        VPP_GLOBAL_BLOCKBASE_INF
    #define    VPP_GLOBAL_BLOCKBASE_INF
    #define    BLOCK_VPP_GLOBAL_VERSION 1
    #define    BLOCK_VPP_GLOBAL_TIMESTAMP "2020/4/2 11:06:19"
    #define    VPP_GLOBAL_BLOCK                                           0x10 // match with BlockID.h
    #define    VPP_GLOBAL_REG_START                                       0x0 // match with BlockID.h
    #define    VPP_GLOBAL_REG_END                                         0x1CC // match with BlockID.h
    #define    VPP_GLOBAL_REG_LIMIT                                       0x1CC // match with BlockID.h
#endif

// Register offset definition
#define        Reg_Src_Base_Offset                                        0x0
#define        Reg_Oth_Base_Offset                                        0x1
#define        Reg_Ref_Base_Offset                                        0x2
#define        Reg_Range_Set0_Offset                                      0x3
#define        Reg_Range_Set1_Offset                                      0x4
#define        Reg_Dst_Base_Offset                                        0x5
#define        Reg_Scl_Dst_Base_0_Offset                                  0x6
#define        Reg_Scl_Dst_Base_1_Offset                                  0x7
#define        Reg_Scl_Dst_Height_Offset                                  0x8
#define        Reg_Bot_Base_0_Offset                                      0x9
#define        Reg_Bot_Base_1_Offset                                      0xA
#define        Reg_Bot_Base_2_Offset                                      0xB
#define        Reg_Hdr_Lut_Base_Offset                                    0xC
#define        Reg_Hdr_Ysum_Base_Offset                                   0xD
#define        Reg_Yv12_Base_U_Offset                                     0xE
#define        Reg_Yv12_Base_V_Offset                                     0xF
#define        Reg_Yv12_Base_Yuv0_Offset                                  0x10
#define        Reg_Scl_Para_Error_Offset                                  0x11
#define        Reg_Src_Sf_0_Offset                                        0x12
#define        Reg_Src_Sf_1_Offset                                        0x13
#define        Reg_Scl_Dst_Sf_1_Offset                                    0x14
#define        Reg_Scl_Dst_Sf_2_Offset                                    0x15
#define        Reg_Vpp_Ref_Sf_Offset                                      0x16
#define        Reg_Mode_Set_Offset                                        0x17
#define        Reg_Drv_Mp_Set_Offset                                      0x18
#define        Reg_Multipass_Set0_Offset                                  0x19
#define        Reg_Multipass_Set1_Offset                                  0x1A
#define        Reg_Md5_Set0_Offset                                        0x1B
#define        Reg_Clip_L_R_Offset                                        0x1C
#define        Reg_Clip_T_B_Offset                                        0x1D
#define        Reg_Lbuf_Set0_Offset                                       0x1E
#define        Reg_Lbuf_Set0_1_Offset                                     0x1F
#define        Reg_Lbuf_Set0_2_Offset                                     0x20
#define        Reg_Lbuf_Set0_3_Offset                                     0x21
#define        Reg_Lbuf_Set1_Offset                                       0x22
#define        Reg_Lbuf_Set2_Offset                                       0x23
#define        Reg_Lbuf_Set3_Offset                                       0x24
#define        Reg_Lbuf_Set4_Offset                                       0x25
#define        Reg_Lbuf_Set5_Offset                                       0x26
#define        Reg_Img_Related_Offset                                     0x27
#define        Reg_Hslc_Set0_Offset                                       0x28
#define        Reg_Hslc_Set1_Offset                                       0x29
#define        Reg_Hslc_Set2_Offset                                       0x2A
#define        Reg_Scl_Para_Sd_Offset                                     0x2B
#define        Reg_Scl_Para_Ds_Offset                                     0x2C
#define        Reg_Scl_0_Offset                                           0x2D
#define        Reg_Cscf_00_01_Offset                                      0x2E
#define        Reg_Cscf_02_10_Offset                                      0x2F
#define        Reg_Cscf_11_12_Offset                                      0x30
#define        Reg_Cscf_20_21_Offset                                      0x31
#define        Reg_Cscf_22_Offset                                         0x32
#define        Reg_Cscf_Off_00_Offset                                     0x33
#define        Reg_Cscf_Off_01_Offset                                     0x34
#define        Reg_Cscf_Off_02_Offset                                     0x35
#define        Reg_Cscb_00_01_Offset                                      0x36
#define        Reg_Cscb_02_10_Offset                                      0x37
#define        Reg_Cscb_11_12_Offset                                      0x38
#define        Reg_Cscb_20_21_Offset                                      0x39
#define        Reg_Cscb_22_Offset                                         0x3A
#define        Reg_Cscb_Off_00_Offset                                     0x3B
#define        Reg_Cscb_Off_01_Offset                                     0x3C
#define        Reg_Cscb_Off_02_Offset                                     0x3D
#define        Reg_Ld_Bld_Fixcolor_Offset                                 0x3E
#define        Reg_Cpt_0_Offset                                           0x3F
#define        Reg_Cpt_1_Offset                                           0x40
#define        Reg_Cpt_2_Offset                                           0x41
#define        Reg_Mif_Arbiter_0_Offset                                   0x42
#define        Reg_Mif_Arbiter_1_Offset                                   0x43
#define        Reg_Mif_Arbiter_2_Offset                                   0x44
#define        Reg_Mif_Slot_Idx_0_Offset                                  0x45
#define        Reg_Mif_Slot_Idx_1_Offset                                  0x46
#define        Reg_Mif_Slot_Idx_2_Offset                                  0x47
#define        Reg_Mif_Slot_Idx_3_Offset                                  0x48
#define        Reg_Mif_Slot_Idx_4_Offset                                  0x49
#define        Reg_Mif_Pid_0_Offset                                       0x4A
#define        Reg_Mif_Pid_1_Offset                                       0x4B
#define        Reg_Di_0_Offset                                            0x4C
#define        Reg_Di_1_Offset                                            0x4D
#define        Reg_Di_2_Offset                                            0x4E
#define        Reg_Di_3_Offset                                            0x4F
#define        Reg_Di_4_Offset                                            0x50
#define        Reg_Di_5_Offset                                            0x51
#define        Reg_Di_6_Offset                                            0x52
#define        Reg_Di_7_Offset                                            0x53
#define        Reg_Di_8_Offset                                            0x54
#define        Reg_Di_9_Offset                                            0x55
#define        Reg_Di_A_Offset                                            0x56
#define        Reg_Di_B_Offset                                            0x57
#define        Reg_Di_C_Offset                                            0x58
#define        Reg_Di_D_Offset                                            0x59
#define        Reg_Di_E_Offset                                            0x5A
#define        Reg_Vpp_Control_0_Offset                                   0x5B
#define        Reg_Vpp_Control_3_Offset                                   0x5C
#define        Reg_Vpp_Control_4_Offset                                   0x5D
#define        Reg_Vpp_Control_5_Offset                                   0x5E
#define        Reg_Vpp_Control_6_Offset                                   0x5F
#define        Reg_Vpp_Control_9_Offset                                   0x60
#define        Reg_Vpp_Lbuf_0_Offset                                      0x61
#define        Reg_Vpp_Lbuf_1_Offset                                      0x62
#define        Reg_Vpp_Fd_Control_0_Offset                                0x63
#define        Reg_Vpp_Fd_Control_1_Offset                                0x64
#define        Reg_Vpp_Fd_Control_2_Offset                                0x65
#define        Reg_Vpp_Fd_Control_3_Offset                                0x66
#define        Reg_Vpp_Fd_Control_4_Offset                                0x67
#define        Reg_Vpp_Fd_Control_5_Offset                                0x68
#define        Reg_Vpp_Fd_Control_6_Offset                                0x69
#define        Reg_Vpp_Fd_Control_7_Offset                                0x6A
#define        Reg_Cg_Ctrl_Offset                                         0x6B
#define        Reg_From_Opcode_Offset                                     0x6C
#define        Reg_Cm_0_Offset                                            0x6D
#define        Reg_Cm_1_Offset                                            0x6E
#define        Reg_Ccm_0_Offset                                           0x97
#define        Reg_Ccm_1_Offset                                           0x98
#define        Reg_Ccm_3_Offset                                           0x99
#define        Reg_Ccm_4_Offset                                           0xA9
#define        Reg_Ccm_5_Offset                                           0xB9
#define        Reg_Ccm_6_Offset                                           0xBA
#define        Reg_Ccm_7_Offset                                           0xCA
#define        Reg_Ccm_8_Offset                                           0xCB
#define        Reg_Ccm_9_Offset                                           0xCC
#define        Reg_Ccm_A_Offset                                           0xCD
#define        Reg_Ccm_B_Offset                                           0xCE
#define        Reg_Ccm_C_Offset                                           0xDE
#define        Reg_Ccm_D_Offset                                           0xDF
#define        Reg_Cc_0_Offset                                            0xE0
#define        Reg_Cc_1_Offset                                            0xE1
#define        Reg_Cc_2_Offset                                            0xE2
#define        Reg_Cc_3_Offset                                            0xE3
#define        Reg_Cc_4_Offset                                            0xE4
#define        Reg_Hadj_0_Offset                                          0xE5
#define        Reg_Hadj_1_Offset                                          0xE6
#define        Reg_Hadj_2_Offset                                          0xE7
#define        Reg_Hadj_3_Offset                                          0xE8
#define        Reg_Sadj_0_Offset                                          0xE9
#define        Reg_Sadj_1_Offset                                          0xEA
#define        Reg_Sadj_2_Offset                                          0xEB
#define        Reg_Sadj_3_Offset                                          0xEC
#define        Reg_Sadj_4_Offset                                          0xED
#define        Reg_Sadj_5_Offset                                          0xEE
#define        Reg_Sadj_6_Offset                                          0xEF
#define        Reg_Sadj_7_Offset                                          0xF0
#define        Reg_Sadj_8_Offset                                          0xF1
#define        Reg_Hdr_0_Offset                                           0xF2
#define        Reg_Hdr_1_Offset                                           0xF3
#define        Reg_Hdr_2_Offset                                           0xF4
#define        Reg_Hdr_3_Offset                                           0xF5
#define        Reg_Hdr_4_Offset                                           0xF6
#define        Reg_Hdr_5_Offset                                           0xF7
#define        Reg_Hdr_6_Offset                                           0xF8
#define        Reg_Hdr_7_Offset                                           0xF9
#define        Reg_Hdr_8_Offset                                           0xFA
#define        Reg_Hdr_9_Offset                                           0xFB
#define        Reg_Hdr_Ylut_0_Offset                                      0xFC
#define        Reg_Hdr_Ylut_1_Offset                                      0xFD
#define        Reg_Hdr_Ylut_2_Offset                                      0xFE
#define        Reg_Hdr_Ylut_3_Offset                                      0xFF
#define        Reg_Hdr_Ylut_4_Offset                                      0x100
#define        Reg_Hdr_Ylut_5_Offset                                      0x101
#define        Reg_Hdr_Ylut_6_Offset                                      0x102
#define        Reg_Hdr_Ylut_7_Offset                                      0x103
#define        Reg_Hdr_Ylut_8_Offset                                      0x104
#define        Reg_Hdr_Ylut_9_Offset                                      0x105
#define        Reg_Hdr_Ylut_A_Offset                                      0x106
#define        Reg_Hdr_Ylut_10_Offset                                     0x107
#define        Reg_Hdr_Ylut_11_Offset                                     0x108
#define        Reg_Hdr_Ylut_12_Offset                                     0x109
#define        Reg_Hdr_Ylut_13_Offset                                     0x10A
#define        Reg_Hdr_Ylut_14_Offset                                     0x10B
#define        Reg_Hdr_Ylut_15_Offset                                     0x10C
#define        Reg_Hdr_Ylut_16_Offset                                     0x10D
#define        Reg_Hdr_Ylut_17_Offset                                     0x10E
#define        Reg_Hdr_Ylut_18_Offset                                     0x10F
#define        Reg_Hdr_Ylut_19_Offset                                     0x110
#define        Reg_Hdr_Ylut_1a_Offset                                     0x111
#define        Reg_Sat_Set_Offset                                         0x112
#define        Reg_Tm_Set_0_Offset                                        0x132
#define        Reg_Tm_Set_1_Offset                                        0x165
#define        Reg_Tm_Set_2_Offset                                        0x198
#define        Reg_Tm_Set_3_Offset                                        0x1CB

// Block constant definition
typedef enum
{
    SRC_SF_1_GB_SRC_FMT_RESERVED_BAYER       = 0,   // 0: Reserved for 10bit Bayer Pattern,
                                                    // D[15:10]=Reserved,D[9:0]=R/G/B
    SRC_SF_1_GB_SRC_FMT_RGB565               = 1,   // 1: RGB565: Bit[15:11]=R,Bit[10:5]=G,Bit[4:0]=B
    SRC_SF_1_GB_SRC_FMT_RGBA8888             = 2,   // 2: 8bit ABGR8888
                                                    // Bit[31:24]=A,Bit[23:16]=B,Bit[15:8]=G,Bit[7:0]=R
    SRC_SF_1_GB_SRC_FMT_BGRA8888             = 3,   // 3: 8bit BGRA8888
                                                    // Bit[31:24]=A,Bit[23:16]=R,Bit[15:8]=G,Bit[7:0]=B
    SRC_SF_1_GB_SRC_FMT_AYUV8888             = 4,   // 4: 8bit AYUV8888
                                                    // Bit[31:24]=A,Bit[23:16]=Y,Bit[15:8]=U,Bit[7:0]=V
    SRC_SF_1_GB_SRC_FMT_YUYV                 = 5,   // 5: 8bit YUV422
                                                    // Bit[31:24]=V,Bit[23:16]=Y1,Bit[15:8]=U
                                                    // ,Bit[7:0]=Y0
    SRC_SF_1_GB_SRC_FMT_UYVY                 = 6,   // 6: 8bit YUV422
                                                    // Bit[31:24]=Y1,Bit[23:16]=V,Bit[15:8]=Y0
    SRC_SF_1_GB_SRC_FMT_NV12                 = 7,   // 7:?8?bits?YUV420 Yplane, Y surface and UV surface
    SRC_SF_1_GB_SRC_FMT_NV21                 = 8,   // 8: 8?bits?YUV420 Yplane ?Y surface and VU surface
    SRC_SF_1_GB_SRC_FMT_YV12                 = 9,   // 9:?8?bits?YUV420 Yplane? Y surface and U surface and V
                                                    // surface
    SRC_SF_1_GB_SRC_FMT_ARGB2101010          = 10,  // 10: 10bit ARGB. Bit[31:30]=A,
                                                    // Bit[29:20]=R,Bit[19:10]=G,Bit[9:0]=B
    SRC_SF_1_GB_SRC_FMT_ABGR2101010          = 11,  // 11: 10bit ABGR. Bit[31:30]=A,
                                                    // Bit[29:20]=B,Bit[19:10]=G,Bit[9:0]=R
    SRC_SF_1_GB_SRC_FMT_UYVA1010102          = 12,  // 12: 10bit YUV444. Bit[31:30]=A,
                                                    // Bit[29:20]=V,Bit[19:10]=Y,Bit[9:0]=U
    SRC_SF_1_GB_SRC_FMT_RESERVED_Y210        = 13,  // 13: 10bit YUV422 Bit[63:54]=V, Bit[47:38]=Y1,
                                                    // Bit[31:22]=U, Bit[15:6]=Y0
    SRC_SF_1_GB_SRC_FMT_P010                 = 14,  // 14: 10bit YUV420 Bit[15:6] for every channel, [5:0]=0, Y
                                                    // surface and UV surface
} SRC_SF_1_GB_SRC_FMT;
typedef enum
{
    SRC_SF_1_GB_SRC_TILE_LINEAR              = 0,   // 0: linear format
    SRC_SF_1_GB_SRC_TILE_TILE                = 1,   // 1: tile format
} SRC_SF_1_GB_SRC_TILE;
typedef enum
{
    SCL_DST_SF_1_GB_SCL_DST_FMT_RESERVED_BAYER= 0,  // 0: Reserved for 10bit Bayer Pattern,
                                                    // D[15:10]=Reserved,D[9:0]=R/G/B
    SCL_DST_SF_1_GB_SCL_DST_FMT_RGB565       = 1,   // 1: RGB565: Bit[15:11]=R,Bit[10:5]=G,Bit[4:0]=B
    SCL_DST_SF_1_GB_SCL_DST_FMT_RGBA8888     = 2,   // 2: 8bit ABGR8888
                                                    // Bit[31:24]=A,Bit[23:16]=B,Bit[15:8]=G,Bit[7:0]=R
    SCL_DST_SF_1_GB_SCL_DST_FMT_BGRA8888     = 3,   // 3: 8bit BGRA8888
                                                    // Bit[31:24]=A,Bit[23:16]=R,Bit[15:8]=G,Bit[7:0]=B
    SCL_DST_SF_1_GB_SCL_DST_FMT_AYUV8888     = 4,   // 4: 8bit AYUV8888
                                                    // Bit[31:24]=A,Bit[23:16]=Y,Bit[15:8]=U,Bit[7:0]=V
    SCL_DST_SF_1_GB_SCL_DST_FMT_YUYV         = 5,   // 5: 8bit YUV422
                                                    // Bit[31:24]=V,Bit[23:16]=Y1,Bit[15:8]=U
                                                    // ,Bit[7:0]=Y0
    SCL_DST_SF_1_GB_SCL_DST_FMT_UYVY         = 6,   // 6: 8bit YUV422
                                                    // Bit[31:24]=Y1,Bit[23:16]=V,Bit[15:8]=Y0
    SCL_DST_SF_1_GB_SCL_DST_FMT_NV12         = 7,   // 7:?8?bits?YUV420 Yplane, Y surface and UV surface
    SCL_DST_SF_1_GB_SCL_DST_FMT_NV21         = 8,   // 8: 8?bits?YUV420 Yplane ?Y surface and VU surface
    SCL_DST_SF_1_GB_SCL_DST_FMT_YV12         = 9,   // 9:?8?bits?YUV420 Yplane? Y surface and U surface and V
                                                    // surface
    SCL_DST_SF_1_GB_SCL_DST_FMT_ARGB2101010  = 10,  // 10: 10bit ARGB. Bit[31:30]=A,
                                                    // Bit[29:20]=R,Bit[19:10]=G,Bit[9:0]=B
    SCL_DST_SF_1_GB_SCL_DST_FMT_ABGR2101010  = 11,  // 11: 10bit ABGR. Bit[31:30]=A,
                                                    // Bit[29:20]=B,Bit[19:10]=G,Bit[9:0]=R
    SCL_DST_SF_1_GB_SCL_DST_FMT_UYVA1010102  = 12,  // 12: 10bit YUV444. Bit[31:30]=A,
                                                    // Bit[29:20]=V,Bit[19:10]=Y,Bit[9:0]=U
    SCL_DST_SF_1_GB_SCL_DST_FMT_RESERVED_Y210= 13,  // 13: 10bit YUV422 Bit[63:54]=V, Bit[47:38]=Y1,
                                                    // Bit[31:22]=U, Bit[15:6]=Y0
    SCL_DST_SF_1_GB_SCL_DST_FMT_P010         = 14,  // 14: 10bit YUV420 Bit[15:6] for every channel, [5:0]=0, Y
                                                    // surface and UV surface
} SCL_DST_SF_1_GB_SCL_DST_FMT;
typedef enum
{
    SCL_DST_SF_1_GB_SCL_DST_COMPRESS_EN_DISABLE= 0, // 0: disable
    SCL_DST_SF_1_GB_SCL_DST_COMPRESS_EN_ENABLE= 1,  // 1: enable
} SCL_DST_SF_1_GB_SCL_DST_COMPRESS_EN;
typedef enum
{
    MODE_SET_GB_BLT_MODE_DISABLE             = 0,   // 0: disable blt
    MODE_SET_GB_BLT_MODE_ENABLE              = 1,   // 1: enable blt
} MODE_SET_GB_BLT_MODE;
typedef enum
{
    MODE_SET_GB_SCL_MODE_BILINEAR            = 0,   // 0: bilinear/acc scaling
    MODE_SET_GB_SCL_MODE_BICUBIC             = 1,   // 1: bicubic scaling
} MODE_SET_GB_SCL_MODE;
typedef enum
{
    MODE_SET_GB_EN_HSCL_DISABLE              = 0,   // 0x: disable
    MODE_SET_GB_EN_HSCL_UPSCALING            = 2,   // 10: upscaling
    MODE_SET_GB_EN_HSCL_DOWNSCALING          = 3,   // 11: down scaling
} MODE_SET_GB_EN_HSCL;
typedef enum
{
    MODE_SET_GB_EN_VSCL_DISABLE              = 0,   // 0x: disable
    MODE_SET_GB_EN_VSCL_UPSCALING            = 2,   // 10: upscaling
    MODE_SET_GB_EN_VSCL_DOWNSCALING          = 3,   // 11: down scaling
} MODE_SET_GB_EN_VSCL;
typedef enum
{
    MODE_SET_GB_ROTATION_MODE_DEGREE0        = 0,   // 2'b00: 0 degree
    MODE_SET_GB_ROTATION_MODE_DEGREE90       = 1,   // 2'b01: 90 degree
    MODE_SET_GB_ROTATION_MODE_DEGREE180      = 2,   // 2'b10: 180 degree
    MODE_SET_GB_ROTATION_MODE_DEGREE270      = 3,   // 2'b11: 270 degree
} MODE_SET_GB_ROTATION_MODE;
typedef enum
{
    MODE_SET_GB_EN_4K_MEM_SWZL_DISABLE       = 0,   // 0: disable 
    MODE_SET_GB_EN_4K_MEM_SWZL_ENABLE        = 1,   // 1: enable
} MODE_SET_GB_EN_4K_MEM_SWZL;
typedef enum
{
    DRV_MP_SET_GB_SEQ_ID_PEAKLEVEL_LEVEL0    = 0,   // 0: 1024
    DRV_MP_SET_GB_SEQ_ID_PEAKLEVEL_LEVEL1    = 1,   // 1: 512
    DRV_MP_SET_GB_SEQ_ID_PEAKLEVEL_LEVEL2    = 2,   // 2: 256
    DRV_MP_SET_GB_SEQ_ID_PEAKLEVEL_LEVEL3    = 3,   // 3: 128
} DRV_MP_SET_GB_SEQ_ID_PEAKLEVEL;
typedef enum
{
    MULTIPASS_SET1_GB_SIGNAT_SEL_IO_DISABLED= 0,    // 0: disable io signature
    MULTIPASS_SET1_GB_SIGNAT_SEL_IO_LD       = 1,   // 1: ld input memory data signature
    MULTIPASS_SET1_GB_SIGNAT_SEL_IO_RESERVED_2= 2,  // 2: reserved
    MULTIPASS_SET1_GB_SIGNAT_SEL_IO_MOB_SCL_SF= 3,  // 3: mob scaling surface data signature
} MULTIPASS_SET1_GB_SIGNAT_SEL_IO;
typedef enum
{
    MULTIPASS_SET1_GB_SIGNAT_SEL_OO_DISABLED= 0,    // 0: disable oo signature
    MULTIPASS_SET1_GB_SIGNAT_SEL_OO_LD       = 1,   // 1: ld input memory data signature
    MULTIPASS_SET1_GB_SIGNAT_SEL_OO_SCL_SF   = 2,   // 2: scaling surface signature
} MULTIPASS_SET1_GB_SIGNAT_SEL_OO;
typedef enum
{
    MULTIPASS_SET1_GB_SIG_ENADDR_IO_DISABLE  = 0,   // 0: disable
    MULTIPASS_SET1_GB_SIG_ENADDR_IO_ENABLE   = 1,   // 1: enable
} MULTIPASS_SET1_GB_SIG_ENADDR_IO;
typedef enum
{
    LBUF_SET0_GB_VPPARBMODE_FIX              = 0,   // 2'b00: fix priority (default)
    LBUF_SET0_GB_VPPARBMODE_RESERVED         = 1,   // 2'b01: reserved
    LBUF_SET0_GB_VPPARBMODE_ROUND_ROBIN      = 2,   // 2'b10: Round Robin
    LBUF_SET0_GB_VPPARBMODE_LRU              = 3,   // 2'b11: LRU_method
} LBUF_SET0_GB_VPPARBMODE;
typedef enum
{
    MIF_ARBITER_1_GB_MIFARB_PASSIVE_COMPRESSION_MODE= 0,
                                                    // 1'b0: grant only hold for compression
    MIF_ARBITER_1_GB_MIFARB_PASSIVE_PASSIVE_MODE= 1,// 1'b1: grant will be hold until receive grant_end from
                                                    // engine
} MIF_ARBITER_1_GB_MIFARB_PASSIVE;
typedef enum
{
    VPP_FD_CONTROL_2_GB_SCENECHANGE_MD_MODE_TWO_IN= 0,
                                                    // 0: Two input frame reference(cur and next)
    VPP_FD_CONTROL_2_GB_SCENECHANGE_MD_MODE_THREE_IN= 1,
                                                    // 1: Always three input frame reference
} VPP_FD_CONTROL_2_GB_SCENECHANGE_MD_MODE;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////            VPP_GLOBAL Block (Block ID = 16) Register Definitions                     ///////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
#define  Reg_Src_Base_Gb_Src_Sf_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Sf_Base            : 32;  // source surface base, 2k bit aligned [39:8]
    } reg;
} Reg_Src_Base;
 
#define  Reg_Oth_Base_Gb_Oth_Sf_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Oth_Sf_Base            : 32;  // other surface , 2k bit aligned [39:8]
    } reg;
} Reg_Oth_Base;
 
#define  Reg_Ref_Base_Gb_Ref_Sf_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Ref_Sf_Base            : 32;  // reference surface base, 2k bit aligned [39:8]
    } reg;
} Reg_Ref_Base;
 
#define  Reg_Range_Set0_Gb_Src_Range_Map_Y_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Src_Range_Map_Y_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Gb_Src_Range_Map_Uv_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Src_Range_Map_Uv_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Gb_Oth_Range_Map_Y_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Oth_Range_Map_Y_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Gb_Oth_Range_Map_Uv_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Oth_Range_Map_Uv_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Gb_Ref_Range_Map_Y_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Ref_Range_Map_Y_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Gb_Ref_Range_Map_Uv_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set0_Gb_Ref_Range_Map_Uv_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Range_Set0_Reserved_Rs0_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Range_Map_Y_En     : 1;   // enable range map for Y channel
        unsigned int Gb_Src_Range_Map_Y        : 3;   // range map for Y channel
        unsigned int Gb_Src_Range_Map_Uv_En    : 1;   // enable range map for UV channel
        unsigned int Gb_Src_Range_Map_Uv       : 3;   // range map for UV channel
        unsigned int Gb_Oth_Range_Map_Y_En     : 1;   // enable range map for Y channel
        unsigned int Gb_Oth_Range_Map_Y        : 3;   // range map for Y channel
        unsigned int Gb_Oth_Range_Map_Uv_En    : 1;   // enable range map for UV channel
        unsigned int Gb_Oth_Range_Map_Uv       : 3;   // range map for UV channel
        unsigned int Gb_Ref_Range_Map_Y_En     : 1;   // enable range map for Y channel
        unsigned int Gb_Ref_Range_Map_Y        : 3;   // range map for Y channel
        unsigned int Gb_Ref_Range_Map_Uv_En    : 1;   // enable range map for UV channel
        unsigned int Gb_Ref_Range_Map_Uv       : 3;   // range map for UV channel
        unsigned int Reserved_Rs0              : 8;   // reserved
    } reg;
} Reg_Range_Set0;
 
#define  Reg_Range_Set1_Gb_H_Mirror_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set1_Gb_V_Mirror_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Range_Set1_Gb_Src_Range_Type_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Range_Set1_Gb_Dst_Range_Type_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Range_Set1_Reserved_Bm_BitField_MaxValue ((1u << 20) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_H_Mirror_En            : 1;   // Horizontal mirror control signal. 
        unsigned int Gb_V_Mirror_En            : 1;   // Vertical mirror control signal.
        unsigned int Gb_Src_Range_Type         : 5;   // Src surface¡¯s compression range-type.
        unsigned int Gb_Dst_Range_Type         : 5;   // Dst surface¡¯s compression range-type.
        unsigned int Reserved_Bm               : 20;  // reserved
    } reg;
} Reg_Range_Set1;
 
#define  Reg_Dst_Base_Gb_Dst_Sf_Base_0_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Sf_Base_0          : 32;  // default destination surface base [39:8]
    } reg;
} Reg_Dst_Base;
 
#define  Reg_Scl_Dst_Base_0_Gb_Dst_Sf_Base_1_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Sf_Base_1          : 32;  // destination surface base 1 in two frame mode [39:8]
    } reg;
} Reg_Scl_Dst_Base_0;
 
#define  Reg_Scl_Dst_Base_1_Gb_Scl_Dst_Clipx_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Scl_Dst_Base_1_Gb_Scl_Dst_Clipy_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Scl_Dst_Base_1_Reserved_Mob_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Scl_Dst_Clipx          : 13;  // destination surface clip window left position
        unsigned int Gb_Scl_Dst_Clipy          : 13;  // destination surface clip window top position
        unsigned int Reserved_Mob              : 6;   // reserved
    } reg;
} Reg_Scl_Dst_Base_1;
 
#define  Reg_Scl_Dst_Height_Gb_Scl_Dst_Sf_Height_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Scl_Dst_Height_Reserved_Sdb2_BitField_MaxValue ((1u << 18) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Scl_Dst_Sf_Height      : 14;  // scaled destination surface hegiht
        unsigned int Reserved_Sdb2             : 18;  // reserved
    } reg;
} Reg_Scl_Dst_Height;
 
#define  Reg_Bot_Base_0_Gb_Src_Sf_Bot_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Sf_Bot_Base        : 32;  // Input SRC bottom field surface base, 2k bit aligned
                                                      // [39:8], only used in field mode
    } reg;
} Reg_Bot_Base_0;
 
#define  Reg_Bot_Base_1_Gb_Oth_Sf_Bot_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Oth_Sf_Bot_Base        : 32;  // Input OTH bottom field surface base, 2k bit aligned
                                                      // [39:8], only used in field mode
    } reg;
} Reg_Bot_Base_1;
 
#define  Reg_Bot_Base_2_Gb_Ref_Sf_Bot_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Ref_Sf_Bot_Base        : 32;  // Input REF bottom field surface base, 2k bit aligned
                                                      // [39:8], only used in field mode
    } reg;
} Reg_Bot_Base_2;
 
#define  Reg_Hdr_Lut_Base_Gb_Hdr_Int_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Int_Base           : 32;  // memory base for hdr map lut
    } reg;
} Reg_Hdr_Lut_Base;
 
#define  Reg_Hdr_Ysum_Base_Gb_Ysum_Mem_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Ysum_Mem_Base          : 32;  // Memory base of YSum, 512bit align. Ysum should be
                                                      // calculated by VCP for HDR use, 2 DW. [31:0]
    } reg;
} Reg_Hdr_Ysum_Base;
 
#define  Reg_Yv12_Base_U_Gb_Dst_Sf_Base_Uv_0_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Sf_Base_Uv_0       : 32;  // If format is YV12, u surface base ; otherwise, uv default
                                                      // surface base. [39:8]
    } reg;
} Reg_Yv12_Base_U;
 
#define  Reg_Yv12_Base_V_Gb_Dst_Sf_Base_Uv_1_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Sf_Base_Uv_1       : 32;  // If format is YV12, v surface base ; otherwise, uv surface
                                                      // base 1 in two frame mode. [39:8]
    } reg;
} Reg_Yv12_Base_V;
 
#define  Reg_Yv12_Base_Yuv0_Gb_Dst_Sf_Base_0_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Yv12_Base_Yuv0_Gb_Dst_Sf_Base_Uv_0_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Yv12_Base_Yuv0_Gb_Dst_Sf_Base_Uv_1_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Yv12_Base_Yuv0_Gb_Rgb888_Consecutive_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Yv12_Base_Yuv0_Reserved_Yuv0_BitField_MaxValue ((1u << 7) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Sf_Base_0          : 8;   // default destination surface base. [7:0]
        unsigned int Gb_Dst_Sf_Base_Uv_0       : 8;   // If format is YV12, u surface base ; otherwise, uv default
                                                      // surface base. [7:0]
        unsigned int Gb_Dst_Sf_Base_Uv_1       : 8;   // If format is YV12, v surface base ; otherwise, uv surface
                                                      // base 1 in two frame mode. [7:0]
        unsigned int Gb_Rgb888_Consecutive     : 1;   // RGB888 consecutive
        unsigned int Reserved_Yuv0             : 7;   // reserved
    } reg;
} Reg_Yv12_Base_Yuv0;
 
#define  Reg_Scl_Para_Error_Gb_Hs_Error_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Scl_Para_Error_Gb_Vs_Error_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Scl_Para_Error_Gb_Ysum_Mem_Base_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hs_Error               : 15;  // Initial Hs_error for horizontal scaling
                                                      //  for down scaling: Fix .11
                                                      //  for up scaling: Fix .15
        unsigned int Gb_Vs_Error               : 15;  // Initial Vs_error for vertical scaling
                                                      //  for down scaling: Fix .11
                                                      //  for up scaling: Fix .15
        unsigned int Gb_Ysum_Mem_Base          : 2;   // Memory base of YSum, 512bit align. Ysum should be
                                                      // calculated by VCP for HDR use, 2 DW. [33:32]
    } reg;
} Reg_Scl_Para_Error;
 
#define  Reg_Src_Sf_0_Gb_Src_Width_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Src_Sf_0_Gb_Seq_Id_Thrd_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Src_Sf_0_Reserved_Src_Sf_0_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Width              : 14;  // source width
        unsigned int Gb_Seq_Id_Thrd            : 8;   // for performance tune: a threshold  to make request more
                                                      // longer
        unsigned int Reserved_Src_Sf_0         : 10;  // reserved
    } reg;
} Reg_Src_Sf_0;
 
#define  Reg_Src_Sf_1_Reserved_Src_Sf_1_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Src_Sf_1_Gb_Src_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Src_Sf_1_Gb_Src_Tile_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Src_Sf_1_Gb_Src_Height_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Src_Sf_1_Gb_Src_Pitch_BitField_MaxValue ((1u << 11) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_Src_Sf_1         : 2;   // reserved
        unsigned int Gb_Src_Fmt                : 4;   // source format
        unsigned int Gb_Src_Tile               : 1;   // source is tile or linear
        unsigned int Gb_Src_Height             : 14;  // source height, Max Height 4096
        unsigned int Gb_Src_Pitch              : 11;  // source pitch, in the unit of 32 Bytes
    } reg;
} Reg_Src_Sf_1;
 
#define  Reg_Scl_Dst_Sf_1_Gb_Scl_Dst_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Scl_Dst_Sf_1_Gb_Scl_Dst_Height_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Scl_Dst_Sf_1_Gb_Scl_Dst_Pitch_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Scl_Dst_Sf_1_Gb_Scl_Dst_Compress_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_Dst_Sf_1_Reserved_Scl_Dst_Sf_1_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Scl_Dst_Fmt            : 4;   // scaled destination format
        unsigned int Gb_Scl_Dst_Height         : 14;  // scaling will output to scaled plane with line number = 
                                                      // gb_scl_dst_height for each line of the whole image. 
                                                      //  scaling will drop redundant scaled lines when there are
                                                      // more source lines. 
                                                      //  Max value is 4096
        unsigned int Gb_Scl_Dst_Pitch          : 11;  // destination pitch, in the unit of 32 Bytes
        unsigned int Gb_Scl_Dst_Compress_En    : 1;   // scaling destination data should be compressed
        unsigned int Reserved_Scl_Dst_Sf_1     : 2;   // Reserved
    } reg;
} Reg_Scl_Dst_Sf_1;
 
#define  Reg_Scl_Dst_Sf_2_Gb_Scl_Dst_Width_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Scl_Dst_Sf_2_Reserve_Dst2_BitField_MaxValue ((1u << 18) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Scl_Dst_Width          : 14;  // scaling will output to scaled plane with pixel number = 
                                                      // gb_scl_dst_width for each line of the whole image. 
                                                      //  scaling will drop redundant scaled pixels when there are
                                                      // more source pixels. 
                                                      //  Max value is 8192.
        unsigned int Reserve_Dst2              : 18;  // reserved
    } reg;
} Reg_Scl_Dst_Sf_2;
 
#define  Reg_Vpp_Ref_Sf_Reserved_Rs_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Vpp_Ref_Sf_Gb_Vpp_Dnref_Sf_Pitch_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Vpp_Ref_Sf_Gb_Vpp_Dnref_Sf_Height_BitField_MaxValue ((1u << 13) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_Rs               : 8;   // reserved
        unsigned int Gb_Vpp_Dnref_Sf_Pitch     : 11;  // ref surface pitch, in the unit of 32bytes
        unsigned int Gb_Vpp_Dnref_Sf_Height    : 13;  // ref surface height, max height 4096
    } reg;
} Reg_Vpp_Ref_Sf;
 
#define  Reg_Mode_Set_Gb_Blt_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_Scl_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_En_Hscl_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_En_Vscl_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Reserved_Gb_First_Slice_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Se_Vpp_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_Rotation_Mode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Src_Compress_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_For_Eco_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Ds_24_X_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Ds_24_Y_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Blt_Simple_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_En_4k_Mem_Swzl_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_Ds4_Lsb2force_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mode_Set_Gb_Fixcolor_Mode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Mode_Set_Gb_Upsample_Mode_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Mode_Set_Reserved_Ms_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Blt_Mode               : 1;   // blt 8P/1T mode
        unsigned int Gb_Scl_Mode               : 1;   // scaling mode
        unsigned int Gb_En_Hscl                : 2;   // horizontal scaling mode
        unsigned int Gb_En_Vscl                : 2;   // vertical scaling mode
        unsigned int Reserved_Gb_First_Slice   : 2;   // reserved
        unsigned int Gb_Se_Vpp                 : 1;   // security bit set for vpp
        unsigned int Gb_Rotation_Mode          : 2;   // rotation mode in clock wise
        unsigned int Gb_Src_Compress           : 1;   // to mark src is compressed or not
                                                      //  1: map format to range type 
                                                      //  0: set rangetype as rangeoff
        unsigned int Gb_For_Eco                : 2;   // reserved for possible ECO use
        unsigned int Gb_Ds_24_X                : 2;   // LD do downscaling in x direction : ratio = 2^(-gb_ds_24x)
        unsigned int Gb_Ds_24_Y                : 2;   // LD do downscaling in y direction : ratio = 2^(-gb_ds_24y)
        unsigned int Gb_Blt_Simple             : 1;   // Simplefastblt mode for tile output case
        unsigned int Gb_En_4k_Mem_Swzl         : 1;   // do 4KB memory swizzle for tiled surface
        unsigned int Gb_Ds4_Lsb2force          : 1;   // When set it to 1'b1, LD will force data[1:0] to 2'b00 before
                                                      // calc in y direction when (linear_mode |
                                                      // rgb32b_tile_mode)  & ds4.
                                                      //  It is only to sync the design/cmodel verification, real
                                                      // chip should not use it
        unsigned int Gb_Fixcolor_Mode          : 2;   // 0: disable
                                                      //  1: fixcolor fill //in this case, we do not care background
                                                      // issue
                                                      //  2: fixcolor background for compress case
        unsigned int Gb_Upsample_Mode          : 3;   // 0: Mepg-2 siting mode, solved by catmull-rom
                                                      // interpolation 
                                                      //  1: Mepg-1 siting mode, solved by catmull-rom
                                                      // interpolation
                                                      //  2: UHD-Blueray siting mode, solved by catmull-rom
                                                      // interpolation
                                                      //  3: Copy mode, duplicate source chroma to generate full
                                                      // YUV444
                                                      //  4: Average mode, simple average interpolation 
        unsigned int Reserved_Ms               : 6;   // reserved
    } reg;
} Reg_Mode_Set;
 
#define  Reg_Drv_Mp_Set_Reserved_Gb_Scl_Left_Edge_Width_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Drv_Mp_Set_Reserved_Gb_Scl_Right_Edge_Width_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Drv_Mp_Set_Gb_Ldrd_Compress_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Drv_Mp_Set_Gb_Seq_Id_Peaklevel_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Drv_Mp_Set_Reserved_Dms_BitField_MaxValue ((1u << 13) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_Gb_Scl_Left_Edge_Width : 8;
                                                      // reserved
        unsigned int Reserved_Gb_Scl_Right_Edge_Width : 8;
                                                      // reserved
        unsigned int Gb_Ldrd_Compress          : 1;   // LD access memory using compress style in compress mode.
                                                      //  0: Enable LD compress read optimization
                                                      //  1: Disable LD compress read optimization
        unsigned int Gb_Seq_Id_Peaklevel       : 2;   // used to limit the number of seq_id to be used (total 1024)
        unsigned int Reserved_Dms              : 13;  // reserved
    } reg;
} Reg_Drv_Mp_Set;
 
#define  Reg_Multipass_Set0_Gb_Slice_Width_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Multipass_Set0_Gb_Slice_Pixel_Num_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Multipass_Set0_Gb_Slice_Width_1st_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Slice_Width            : 14;  // slice width of multipass
        unsigned int Gb_Slice_Pixel_Num        : 14;  // scaling will output to original or scaled plane with pixel
                                                      // number =  gb_slice_pixel_num for each line in the slice
                                                      // (except last slice).
                                                      //  gb_scl_dst_align = 1: for scaled plane;
                                                      //  gb_scl_dst_align = 0: for original plane.
                                                      //  By adjust gb_slice_pixel_num, each line of a slice can
                                                      // have N*2Kbit data in memory.
        unsigned int Gb_Slice_Width_1st        : 4;   // 1st slice' width, [3:0]
    } reg;
} Reg_Multipass_Set0;
 
#define  Reg_Multipass_Set1_Gb_Slice_Pixel_Num_1st_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Multipass_Set1_Gb_Signat_Sel_Io_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Multipass_Set1_Gb_Signat_Sel_Oo_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Multipass_Set1_Gb_Slice_Width_1st_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Multipass_Set1_Gb_Sig_Enaddr_Io_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Multipass_Set1_Reserved_Mp1_BitField_MaxValue ((1u << 3) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Slice_Pixel_Num_1st    : 14;  // scaling will output to original or scaled plane with pixel
                                                      // number = gb_slice_pixel_num_1st for each line in the 1st
                                                      // slice:
                                                      //  
                                                      //  gb_scl_dst_align = 1: it is for scaled plane;
                                                      //  
                                                      //  gb_scl_dst_align = 0: it is for original plane.
        unsigned int Gb_Signat_Sel_Io          : 2;   // in-order signature mode select
        unsigned int Gb_Signat_Sel_Oo          : 2;   // out-of-order signature mode select
        unsigned int Gb_Slice_Width_1st        : 10;  // 1st slice' width, [13:4]
        unsigned int Gb_Sig_Enaddr_Io          : 1;   // enable address data in in-order signature calculation
        unsigned int Reserved_Mp1              : 3;   // reserved
    } reg;
} Reg_Multipass_Set1;
 
#define  Reg_Md5_Set0_Gb_Md5_Mode_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Md5_Set0_Gb_Md5_Bitdepth_Y_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Md5_Set0_Gb_Md5_Bitdepth_Uv_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Md5_Set0_Gb_Md5_Proc_Mode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Md5_Set0_Reserved_Md50_BitField_MaxValue ((1u << 21) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Md5_Mode_En            : 1;   // MD5 function enable control flag
        unsigned int Gb_Md5_Bitdepth_Y         : 4;   // MD5 input y channel validate bit depth, mostly work with
                                                      // HSF_P010T data from VCP
        unsigned int Gb_Md5_Bitdepth_Uv        : 4;   // MD5 input chrome channel validate bit depth, mostly work
                                                      // with HSF_P010T data from VCP
        unsigned int Gb_Md5_Proc_Mode          : 2;   // MD5 process mode:
                                                      //  0 : frame mode
                                                      //  1 : top-field mode
                                                      //  2 : bottom-field mode
        unsigned int Reserved_Md50             : 21;  // reserved
    } reg;
} Reg_Md5_Set0;
 
#define  Reg_Clip_L_R_Gb_Cl_Left_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Clip_L_R_Gb_Cl_Right_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Clip_L_R_Reserved17_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cl_Left                : 13;  // left position, MAX 8192,Lower 2 bits is offset in a 4 pixels
                                                      // use to mask in final output
        unsigned int Gb_Cl_Right               : 13;  // right position, MAX 8192,Lower 2 bits is offset in a 4
                                                      // pixels use to mask in final output
        unsigned int Reserved17                : 6;   // reserved
    } reg;
} Reg_Clip_L_R;
 
#define  Reg_Clip_T_B_Gb_Cl_Top_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Clip_T_B_Gb_Cl_Bottom_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Clip_T_B_Reserved16_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cl_Top                 : 13;  // top position, MAX 4096
        unsigned int Gb_Cl_Bottom              : 13;  // botton position,MAX 4096
        unsigned int Reserved16                : 6;   // reserved
    } reg;
} Reg_Clip_T_B;
 
#define  Reg_Lbuf_Set0_Gb_Vppcntout_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Lbuf_Set0_Gb_Vpparbmode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Lbuf_Set0_Gb_Lb_Scl_Yuv_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_Gb_Lb_Scl_A_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_Reserved_Ls0_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Vppcntout              : 4;   // The maximum count of once request data number.
                                                      //  Default: 4'b0 (no limit)
        unsigned int Gb_Vpparbmode             : 2;   // The arbitration method
        unsigned int Gb_Lb_Scl_Yuv_Offset      : 11;  // The start position of yuv channel's data in lbf
        unsigned int Gb_Lb_Scl_A_Offset        : 11;  // The start position of alpha channel's data in lbf
        unsigned int Reserved_Ls0              : 4;   // reserved
    } reg;
} Reg_Lbuf_Set0;
 
#define  Reg_Lbuf_Set0_1_Gb_Lb_Scl_Yuv_Pitch_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set0_1_Gb_Lb_Scl_A_Pitch_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set0_1_Gb_Lb_Nm_Oper_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_1_Reserved_Ls01_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lb_Scl_Yuv_Pitch       : 10;  // The length of yuv channel's data in lbf
        unsigned int Gb_Lb_Scl_A_Pitch         : 10;  // The length of alpha channel's data in lbf
        unsigned int Gb_Lb_Nm_Oper_Offset      : 11;  // The start position of nm data in lbf
        unsigned int Reserved_Ls01             : 1;   // reserved
    } reg;
} Reg_Lbuf_Set0_1;
 
#define  Reg_Lbuf_Set0_2_Gb_Lb_Sr_Y_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_2_Gb_Lb_Sr_Uv_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_2_Gb_Lb_Sr_Y_Pitch_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lb_Sr_Y_Offset         : 11;  // The start position of y channel in lbf.
        unsigned int Gb_Lb_Sr_Uv_Offset        : 11;  // The start position of uv channel in lbf.
        unsigned int Gb_Lb_Sr_Y_Pitch          : 10;  // The length of y channel in lbf.
    } reg;
} Reg_Lbuf_Set0_2;
 
#define  Reg_Lbuf_Set0_3_Gb_Lb_Sr_A_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Lbuf_Set0_3_Gb_Lb_Sr_Uv_Pitch_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set0_3_Gb_Lb_Sr_A_Pitch_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set0_3_Reserved_Ls03_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lb_Sr_A_Offset         : 11;  // The start position of a channel in lbf.
        unsigned int Gb_Lb_Sr_Uv_Pitch         : 10;  // The length of uv channel in lbf.
        unsigned int Gb_Lb_Sr_A_Pitch          : 10;  // The length of a channel in lbf.
        unsigned int Reserved_Ls03             : 1;   // reserved
    } reg;
} Reg_Lbuf_Set0_3;
 
#define  Reg_Lbuf_Set1_Gb_Lbadiw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set1_Gb_Lbasclyuvw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set1_Gb_Lbasclaw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set1_Gb_Lbasruvw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set1_Gb_Lba_Bank_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Lbuf_Set1_Reserved_Ls1_BitField_MaxValue ((1u << 7) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbadiw                 : 6;   // line buffer priority for DI write
        unsigned int Gb_Lbasclyuvw             : 6;   // line buffer priority for scaling yuv write
        unsigned int Gb_Lbasclaw               : 6;   // line buffer priority for scaling alpha write
        unsigned int Gb_Lbasruvw               : 6;   // line buffer priority for scaling SR uv write
        unsigned int Gb_Lba_Bank_Mode          : 1;   // 0:  split bank with addr up/bottom
                                                      //  1:  split bank with addr odd/even
        unsigned int Reserved_Ls1              : 7;   // reserved
    } reg;
} Reg_Lbuf_Set1;
 
#define  Reg_Lbuf_Set2_Gb_Lbasryw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set2_Gb_Lbasraw_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Lbuf_Set2_Reserved_Ls2_BitField_MaxValue ((1u << 20) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbasryw                : 6;   // line buffer priority for scaling SR y write
        unsigned int Gb_Lbasraw                : 6;   // line buffer priority for scaling SR alpha write
        unsigned int Reserved_Ls2              : 20;  // reserved
    } reg;
} Reg_Lbuf_Set2;
 
#define  Reg_Lbuf_Set3_Gb_Lbadir_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set3_Gb_Lbadirefr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set3_Gb_Lbascrr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set3_Reserved_Ls3_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbadir                 : 8;   // line buffer priority for MOB read
        unsigned int Gb_Lbadirefr              : 8;   // line buffer priority for DI read
        unsigned int Gb_Lbascrr                : 8;   // line buffer priority for DI reference read
        unsigned int Reserved_Ls3              : 8;   // reserved
    } reg;
} Reg_Lbuf_Set3;
 
#define  Reg_Lbuf_Set4_Gb_Lbasclyuvr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set4_Gb_Lbasclar_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set4_Gb_Lbasruvr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Lbuf_Set4_Reserved_Ls4_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbasclyuvr             : 8;   // line buffer priority for SCR read
        unsigned int Gb_Lbasclar               : 8;   // line buffer priority for scaling YUV read
        unsigned int Gb_Lbasruvr               : 8;   // line buffer priority for scaling alpha read
        unsigned int Reserved_Ls4              : 8;   // reserved
    } reg;
} Reg_Lbuf_Set4;
 
#define  Reg_Lbuf_Set5_Gb_Lbasryr_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set5_Gb_Lbasrar_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Lbuf_Set5_Reserved_Ls5_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbasryr                : 10;  // line buffer priority for scaling SR UV read
        unsigned int Gb_Lbasrar                : 10;  // line buffer priority for scaling SR Y read
        unsigned int Reserved_Ls5              : 12;  // reserved
    } reg;
} Reg_Lbuf_Set5;
 
#define  Reg_Img_Related_Gb_Mob_Fixalpha_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Img_Related_Gb_Redundant_Edge_Width_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Img_Related_Gb_Mob_Range_Min_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Gb_Mob_Range_Maxry_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Img_Related_Gb_Mob_Range_Maxgbuv_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Img_Related_Gb_Src_Lossy_Com_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Gb_Dst_Lossy_Com_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Gb_Mob_Blending_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Gb_Mob_Blending_Diu_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Gb_Mob_Blending_Stream_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Img_Related_Reserved_Ir_BitField_MaxValue ((1u << 9) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mob_Fixalpha           : 8;   // Fix Alpha Value for mob to fill alpha channel 
        unsigned int Gb_Redundant_Edge_Width   : 5;   // the redundant width could be calculated out by HW too by
                                                      // detecting stage enable information to get exact result,
                                                      // however, driver could help to configure
        unsigned int Gb_Mob_Range_Min          : 1;   // Minimum value of rgb/yuv
        unsigned int Gb_Mob_Range_Maxry        : 2;   // Maximum value of r/y
        unsigned int Gb_Mob_Range_Maxgbuv      : 2;   // Maximum value of gb/uv
        unsigned int Gb_Src_Lossy_Com_En       : 1;   // 1: enable src surface lossy compression
                                                      //  0: disable src surface lossy compression
        unsigned int Gb_Dst_Lossy_Com_En       : 1;   // 1: enable dst surface lossy compression
                                                      //  0: disable dst surface lossy compression
        unsigned int Gb_Mob_Blending_En        : 1;   // blending enable
        unsigned int Gb_Mob_Blending_Diu_Mode : 1;    // Select MS mode or DIU mode
        unsigned int Gb_Mob_Blending_Stream_Mode : 1; // Select use pipe alpha or dst alpha
        unsigned int Reserved_Ir               : 9;   // reserved
    } reg;
} Reg_Img_Related;
 
#define  Reg_Hslc_Set0_Gb_Hslc_Y_A0_BitField_MaxValue ((1u << 12) - 1)
#define  Reg_Hslc_Set0_Gb_Hslc_Y_B0_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Hslc_Set0_Reserved_Hslc0_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hslc_Y_A0              : 12;  // Y'=Y*y_a0+y_b0, 4.8
        unsigned int Gb_Hslc_Y_B0              : 14;  // s9.2
        unsigned int Reserved_Hslc0            : 6;   // reserved
    } reg;
} Reg_Hslc_Set0;
 
#define  Reg_Hslc_Set1_Gb_Hslc_Uv_A0_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Hslc_Set1_Gb_Hslc_Uv_A1_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Hslc_Set1_Reserved_Hslc1_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hslc_Uv_A0             : 15;  // U' =uv_a0*U + uv_a1*V +u_b0
                                                      //  s4.10
        unsigned int Gb_Hslc_Uv_A1             : 15;  // s4.10
        unsigned int Reserved_Hslc1            : 2;   // reserved
    } reg;
} Reg_Hslc_Set1;
 
#define  Reg_Hslc_Set2_Gb_Hslc_U_B0_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Hslc_Set2_Gb_Hslc_V_B0_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Hslc_Set2_Reserved_Hslc2_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hslc_U_B0              : 14;  // s9.2
        unsigned int Gb_Hslc_V_B0              : 14;  // V' =-uv_a1*U + uv_a0*V +v_b0
                                                      //  s9.2
        unsigned int Reserved_Hslc2            : 4;   // reserved
    } reg;
} Reg_Hslc_Set2;
 
#define  Reg_Scl_Para_Sd_Gb_Sd_Width_Ratio_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Scl_Para_Sd_Gb_Sd_Height_Ratio_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sd_Width_Ratio         : 16;  // SrcWidth/DestWidth
                                                      //  for down scaling: Fix 5.11
                                                      //  for up scaling: Fix .15 
        unsigned int Gb_Sd_Height_Ratio        : 16;  // SrcHeight/DestHeight
                                                      //  for down scaling: Fix 5.11
                                                      //  for up scaling: Fix .15 
    } reg;
} Reg_Scl_Para_Sd;
 
#define  Reg_Scl_Para_Ds_Gb_Ds_Width_Ratio_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Scl_Para_Ds_Gb_Ds_Height_Ratio_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Scl_Para_Ds_Reserved_Ds_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Ds_Width_Ratio         : 11;  // DestWidth/SrcWidth
                                                      //  for down scaling: Fix .11
                                                      //  for up scaling:  useless
        unsigned int Gb_Ds_Height_Ratio        : 11;  // DestHeight/SrcHeight
                                                      //  for down scaling: Fix .11
                                                      //  for up scaling:  useless
        unsigned int Reserved_Ds               : 10;  // reserved
    } reg;
} Reg_Scl_Para_Ds;
 
#define  Reg_Scl_0_Gb_Src_En_Alpha_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_0_Gb_Scl_Bc_Delta_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Scl_0_Gb_En_Scl_Maxmin_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_0_Gb_En_Sr_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_0_Gb_Sr_Ctdiffth_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Scl_0_Gb_En_Pixeltype_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_0_Gb_Sr_Blendstrength_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Scl_0_Gb_Sr_Enctblend_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Scl_0_Gb_Sr_Blendweight_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Scl_0_Gb_Sr_Coefweight_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Scl_0_Gb_Sr_Coefweightother_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Scl_0_Reserved_Scl0_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_En_Alpha           : 1;   // The enable of alpha channel
        unsigned int Gb_Scl_Bc_Delta           : 5;   // Redundant value for max and min depress
        unsigned int Gb_En_Scl_Maxmin          : 1;   // Bi-cubic Max-Min depress mode , 1 bit, 0x disable, 1
                                                      // enable.
        unsigned int Gb_En_Sr                  : 1;   // The enable of new algorithm, super resolution.
        unsigned int Gb_Sr_Ctdiffth            : 6;   // 1) A threshold that controlls the judgment of flat areas. 
                                                      //  2) We apply comparisons of the intensity values between
                                                      // current pixel and its neighborhood. If most
                                                      // neighborhood's variations in the intensity values are
                                                      // smaller than this threshold, the pixel is in flat area;
                                                      // thus, the blending weight of the initial up-scaling
                                                      // result will be larger.
                                                      //  3) If we set this threshold larger, it will be more easy to
                                                      // judge more pixels in flat areas, and blending weight of the
                                                      // initial up-scaling result will be larger in more pixels,
                                                      // thus the reslut will be more smooth.
        unsigned int Gb_En_Pixeltype           : 1;   // 0: Ori*9+Coherence*3+Strength
                                                      //  1: Ori * 36 + Coherence * 12 + Strength * 4 + PositionType
        unsigned int Gb_Sr_Blendstrength       : 3;   // Global control for filtering level.
        unsigned int Gb_Sr_Enctblend           : 1;   // CT Blending enable signal: 0x1 enable; 0x0 disable
        unsigned int Gb_Sr_Blendweight         : 4;   // Global Blending weight
        unsigned int Gb_Sr_Coefweight          : 4;   // Filter coefficient weight of LUT1/LUT_DN
        unsigned int Gb_Sr_Coefweightother     : 4;   // Filter coefficient weight of LUT2/LUT_SHP
        unsigned int Reserved_Scl0             : 1;   // reserved
    } reg;
} Reg_Scl_0;
 
#define  Reg_Cscf_00_01_Gb_Cscf_M_00_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_00_01_Gb_Cscf_M_01_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_00_01_Gb_Cscf_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cscf_00_01_Gb_Cscf_Round_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cscf_00_01_Reserved_Cscf_00_01_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_M_00              : 13;  // csc matrix row 0 col 0
        unsigned int Gb_Cscf_M_01              : 13;  // csc matrix row 0 col 1
        unsigned int Gb_Cscf_En                : 1;   // the enable of cscf
        unsigned int Gb_Cscf_Round             : 1;   // 0-floor,1-round
        unsigned int Reserved_Cscf_00_01       : 4;   // reserved
    } reg;
} Reg_Cscf_00_01;
 
#define  Reg_Cscf_02_10_Gb_Cscf_M_02_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_02_10_Gb_Cscf_M_10_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_02_10_Reserved_Cscf_02_10_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_M_02              : 13;  // csc matrix row 0 col 2
        unsigned int Gb_Cscf_M_10              : 13;  // csc matrix row 1 col 0
        unsigned int Reserved_Cscf_02_10       : 6;   // reserved
    } reg;
} Reg_Cscf_02_10;
 
#define  Reg_Cscf_11_12_Gb_Cscf_M_11_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_11_12_Gb_Cscf_M_12_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_11_12_Reserved_Cscf_11_12_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_M_11              : 13;  // csc matrix row 1 col 1
        unsigned int Gb_Cscf_M_12              : 13;  // csc matrix row 1 col 2
        unsigned int Reserved_Cscf_11_12       : 6;   // reserved
    } reg;
} Reg_Cscf_11_12;
 
#define  Reg_Cscf_20_21_Gb_Cscf_M_20_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_20_21_Gb_Cscf_M_21_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_20_21_Reserved_Cscf_20_21_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_M_20              : 13;  // csc matrix row 2 col 0
        unsigned int Gb_Cscf_M_21              : 13;  // csc matrix row 2 col 1
        unsigned int Reserved_Cscf_20_21       : 6;   // reserved
    } reg;
} Reg_Cscf_20_21;
 
#define  Reg_Cscf_22_Gb_Cscf_M_22_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscf_22_Reserved_Cscf_22_BitField_MaxValue ((1u << 19) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_M_22              : 13;  // csc matrix row 2 col 2
        unsigned int Reserved_Cscf_22          : 19;  // reserved
    } reg;
} Reg_Cscf_22;
 
#define  Reg_Cscf_Off_00_Gb_Cscf_Off_00_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscf_Off_00_Reserved_Cscf_Off_00_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_Off_00            : 20;  // fixed s11.8;the offset of channel r
        unsigned int Reserved_Cscf_Off_00      : 12;  // reserved
    } reg;
} Reg_Cscf_Off_00;
 
#define  Reg_Cscf_Off_01_Gb_Cscf_Off_01_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscf_Off_01_Reserved_Cscf_Off_01_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_Off_01            : 20;  // fixed s11.8;the offset of channel g
        unsigned int Reserved_Cscf_Off_01      : 12;  // reserved
    } reg;
} Reg_Cscf_Off_01;
 
#define  Reg_Cscf_Off_02_Gb_Cscf_Off_02_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscf_Off_02_Reserved_Cscf_Off_02_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscf_Off_02            : 20;  // fixed s11.8;the offset of channel b
        unsigned int Reserved_Cscf_Off_02      : 12;  // reserved
    } reg;
} Reg_Cscf_Off_02;
 
#define  Reg_Cscb_00_01_Gb_Cscb_M_00_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_00_01_Gb_Cscb_M_01_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_00_01_Gb_Cscb_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cscb_00_01_Gb_Cscb_Round_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cscb_00_01_Reserved_Cscb_00_01_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_M_00              : 13;  // csc matrix row 0 col 0
        unsigned int Gb_Cscb_M_01              : 13;  // csc matrix row 0 col 1
        unsigned int Gb_Cscb_En                : 1;   // the enable of cscb
        unsigned int Gb_Cscb_Round             : 1;   // 0-floor,1-round
        unsigned int Reserved_Cscb_00_01       : 4;   // reserved
    } reg;
} Reg_Cscb_00_01;
 
#define  Reg_Cscb_02_10_Gb_Cscb_M_02_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_02_10_Gb_Cscb_M_10_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_02_10_Reserved_Cscb_02_10_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_M_02              : 13;  // csc matrix row 0 col 2
        unsigned int Gb_Cscb_M_10              : 13;  // csc matrix row 1 col 0
        unsigned int Reserved_Cscb_02_10       : 6;   // reserved
    } reg;
} Reg_Cscb_02_10;
 
#define  Reg_Cscb_11_12_Gb_Cscb_M_11_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_11_12_Gb_Cscb_M_12_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_11_12_Reserved_Cscb_11_12_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_M_11              : 13;  // csc matrix row 1 col 1
        unsigned int Gb_Cscb_M_12              : 13;  // csc matrix row 1 col 2
        unsigned int Reserved_Cscb_11_12       : 6;   // reserved
    } reg;
} Reg_Cscb_11_12;
 
#define  Reg_Cscb_20_21_Gb_Cscb_M_20_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_20_21_Gb_Cscb_M_21_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_20_21_Reserved_Cscb_20_21_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_M_20              : 13;  // csc matrix row 2 col 0
        unsigned int Gb_Cscb_M_21              : 13;  // csc matrix row 2 col 1
        unsigned int Reserved_Cscb_20_21       : 6;   // reserved
    } reg;
} Reg_Cscb_20_21;
 
#define  Reg_Cscb_22_Gb_Cscb_M_22_BitField_MaxValue ((1u << 13) - 1)
#define  Reg_Cscb_22_Reserved_Cscb_22_BitField_MaxValue ((1u << 19) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_M_22              : 13;  // csc matrix row 2 col 2
        unsigned int Reserved_Cscb_22          : 19;  // reserved
    } reg;
} Reg_Cscb_22;
 
#define  Reg_Cscb_Off_00_Gb_Cscb_Off_00_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscb_Off_00_Reserved_Cscb_Off_00_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_Off_00            : 20;  // fixed s11.8;the offset of channel r
        unsigned int Reserved_Cscb_Off_00      : 12;  // reserved
    } reg;
} Reg_Cscb_Off_00;
 
#define  Reg_Cscb_Off_01_Gb_Cscb_Off_01_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscb_Off_01_Reserved_Cscb_Off_01_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_Off_01            : 20;  // fixed s11.8;the offset of channel g
        unsigned int Reserved_Cscb_Off_01      : 12;  // reserved
    } reg;
} Reg_Cscb_Off_01;
 
#define  Reg_Cscb_Off_02_Gb_Cscb_Off_02_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Cscb_Off_02_Reserved_Cscb_Off_02_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cscb_Off_02            : 20;  // fixed s11.8;the offset of channel b
        unsigned int Reserved_Cscb_Off_02      : 12;  // reserved
    } reg;
} Reg_Cscb_Off_02;
 
#define  Reg_Ld_Bld_Fixcolor_Gb_Fixcolor_Value_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fixcolor_Value         : 32;  // ld/bld will not send read request when fixcolor_en is
                                                      // true, send fixcolor to next stage
    } reg;
} Reg_Ld_Bld_Fixcolor;
 
#define  Reg_Cpt_0_Gb_Lb_Cpt_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Cpt_0_Gb_Lb_Cpt_Size_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Cpt_0_Gb_Lb_Mob_L2t_Pitch_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lb_Cpt_Offset          : 11;  // lbuf base for cpt
        unsigned int Gb_Lb_Cpt_Size            : 11;  // lbuf size for cpt
        unsigned int Gb_Lb_Mob_L2t_Pitch       : 10;  // The size of mob linear to tile in lbf
    } reg;
} Reg_Cpt_0;
 
#define  Reg_Cpt_1_Gb_Dst_End_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cpt_1_Gb_Dst_Tile_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cpt_1_Gb_Lb_Mob_L2t_Offset_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Cpt_1_Gb_Mob_Dst_Alphamode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Cpt_1_Gb_Mob_Blending_Mode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Cpt_1_Gb_Mob_Blending_Method_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cpt_1_Gb_Mob_Blending_Rounding_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_End                : 14;  // gb_dst_end =
                                                      // dcPara.InputSclDstWidth+gb_scl_dst_clipx
        unsigned int Gb_Dst_Tile               : 1;   // dst is tile or linear
        unsigned int Gb_Lb_Mob_L2t_Offset      : 11;  // The start address of mob linear to tile in lbf
        unsigned int Gb_Mob_Dst_Alphamode      : 2;   // 0: Fixalpha
                                                      //  1: SrcAlpha
                                                      //  2:DstAlpha
        unsigned int Gb_Mob_Blending_Mode      : 2;   // 0:   Alpha = FixbldAlpha ;
                                                      //  1:   Alpha = SrcData.alpha; //already expand to 8 bit
                                                      //  2:  Alpha =DstData.Alpha; //already expand to 8 bit
        unsigned int Gb_Mob_Blending_Method    : 1;   // Blending method: 0: alpha, 1: 1-alpha
        unsigned int Gb_Mob_Blending_Rounding : 1;    // Rounding = isbldrounding?0x080:0;
    } reg;
} Reg_Cpt_1;
 
#define  Reg_Cpt_2_Gb_Cpt_Dnsample_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cpt_2_Gb_Mob_Bldalpha_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Cpt_2_Gb_Cpt_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cpt_2_Gb_Dst_Sf_Width_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cpt_2_Reserved_Cpt2_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cpt_Dnsample_Mode      : 1;   // 1:  drop odd column
                                                      //  0:   interpolation
        unsigned int Gb_Mob_Bldalpha           : 8;   // The alpha value for bld mode 
        unsigned int Gb_Cpt_En                 : 1;   // cpt enable
        unsigned int Gb_Dst_Sf_Width           : 14;  // destination surface width
        unsigned int Reserved_Cpt2             : 8;   // reserved
    } reg;
} Reg_Cpt_2;
 
#define  Reg_Mif_Arbiter_0_Gb_Mifarb_Reg_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_0_Gb_Mifarb_Ydiff_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_0_Gb_Mifarb_Ld_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_0_Reserved_Ma0_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mifarb_Reg             : 8;   // mif arbiter priority setting of vpp_reg write
        unsigned int Gb_Mifarb_Ydiff           : 8;   // mif arbiter priority setting of ydiff
        unsigned int Gb_Mifarb_Ld              : 8;   // mif arbiter priority setting of ld read
        unsigned int Reserved_Ma0              : 8;   // reserved
    } reg;
} Reg_Mif_Arbiter_0;
 
#define  Reg_Mif_Arbiter_1_Gb_Mifarb_Cptr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_1_Gb_Mifarb_Mtdr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_1_Gb_Mifarb_Mob_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_1_Gb_Mifarb_Passive_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Mif_Arbiter_1_Reserved_Ma1_BitField_MaxValue ((1u << 7) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mifarb_Cptr            : 8;   // mif arbiter priority setting of CPT read
        unsigned int Gb_Mifarb_Mtdr            : 8;   // mif arbiter priority setting of MTD read
        unsigned int Gb_Mifarb_Mob             : 8;   // mif arbiter priority setting of mob write
        unsigned int Gb_Mifarb_Passive         : 1;   // mif arbitration mode
        unsigned int Reserved_Ma1              : 7;   // reserved
    } reg;
} Reg_Mif_Arbiter_1;
 
#define  Reg_Mif_Arbiter_2_Gb_Mifarb_Mtdw_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_2_Gb_Mifarb_Hdrr_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_2_Gb_Mifarb_Hdrw_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Arbiter_2_Reserved_Ma2_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mifarb_Mtdw            : 8;   // mif arbiter priority setting of MTD write
        unsigned int Gb_Mifarb_Hdrr            : 8;   // mif arbiter priority setting of hdr read
        unsigned int Gb_Mifarb_Hdrw            : 8;   // mif arbiter priority setting of hdr write
        unsigned int Reserved_Ma2              : 8;   // reserved
    } reg;
} Reg_Mif_Arbiter_2;
 
#define  Reg_Mif_Slot_Idx_0_Gb_Src_Bl_Slot_Idx_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Mif_Slot_Idx_0_Gb_Oth_Bl_Slot_Idx_BitField_MaxValue ((1u << 14) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Bl_Slot_Idx        : 18;  // Src surface's bl-slot-idx for compression.
        unsigned int Gb_Oth_Bl_Slot_Idx        : 14;  // Oth surface's bl-slot-idx for compression.[13:0]
    } reg;
} Reg_Mif_Slot_Idx_0;
 
#define  Reg_Mif_Slot_Idx_1_Gb_Oth_Bl_Slot_Idx_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Slot_Idx_1_Gb_Ref_Bl_Slot_Idx_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Mif_Slot_Idx_1_Gb_Dst_Bl_Slot_Idx_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Oth_Bl_Slot_Idx        : 4;   // Oth surface's bl-slot-idx for compression.[17:14]
        unsigned int Gb_Ref_Bl_Slot_Idx        : 18;  // Ref surface's bl-slot-idx for compression.
        unsigned int Gb_Dst_Bl_Slot_Idx        : 10;  // Dst surface's bl-slot-idx for compression. [9:0]
    } reg;
} Reg_Mif_Slot_Idx_1;
 
#define  Reg_Mif_Slot_Idx_2_Gb_Dst_Bl_Slot_Idx_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Mif_Slot_Idx_2_Gb_Scl_Dst_Bl_Slot_Idx_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Mif_Slot_Idx_2_Reserved_Msi2_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dst_Bl_Slot_Idx        : 8;   // Dst surface's bl-slot-idx for compression. [17:10]
        unsigned int Gb_Scl_Dst_Bl_Slot_Idx    : 18;  // Scl dst surface's bl-slot-idx for compression.
        unsigned int Reserved_Msi2             : 6;   // reserved
    } reg;
} Reg_Mif_Slot_Idx_2;
 
#define  Reg_Mif_Slot_Idx_3_Gb_Src_Bot_Bl_Slot_Idx_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Mif_Slot_Idx_3_Gb_Oth_Bot_Bl_Slot_Idx_BitField_MaxValue ((1u << 14) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Bot_Bl_Slot_Idx    : 18;  // Src_bot surface's bl-slot-idx for compression.
        unsigned int Gb_Oth_Bot_Bl_Slot_Idx    : 14;  // Oth_bot surface's bl-slot-idx for compression. [13:0]
    } reg;
} Reg_Mif_Slot_Idx_3;
 
#define  Reg_Mif_Slot_Idx_4_Gb_Oth_Bot_Bl_Slot_Idx_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Slot_Idx_4_Gb_Ref_Bot_Bl_Slot_Idx_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Mif_Slot_Idx_4_Reserved_Msi4_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Oth_Bot_Bl_Slot_Idx    : 4;   // Oth_bot surface's bl-slot-idx for compression. [17:14]
        unsigned int Gb_Ref_Bot_Bl_Slot_Idx    : 18;  // Ref_bot surface's bl-slot-idx for compression.
        unsigned int Reserved_Msi4             : 10;  // reserved
    } reg;
} Reg_Mif_Slot_Idx_4;
 
#define  Reg_Mif_Pid_0_Gb_Src_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Oth_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Ref_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Src_Bot_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Oth_Bot_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Ref_Bot_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Dst_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_0_Gb_Scl_Dst_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Src_Proc_Id            : 4;   // Src surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Oth_Proc_Id            : 4;   // Oth surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Ref_Proc_Id            : 4;   // Ref surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Src_Bot_Proc_Id        : 4;   // Src bottom surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Oth_Bot_Proc_Id        : 4;   // Oth bottom surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Ref_Bot_Proc_Id        : 4;   // Ref bottom surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Dst_Proc_Id            : 4;   // Dst surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Scl_Dst_Proc_Id        : 4;   // Scl Dst surface¡¯s proc_id for MXU interface.
    } reg;
} Reg_Mif_Pid_0;
 
#define  Reg_Mif_Pid_1_Gb_Mtd_Hist_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_1_Gb_Hdr_Ysum_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_1_Gb_Hdr_Int_Proc_Id_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Mif_Pid_1_Reserved_Mpid1_BitField_MaxValue ((1u << 20) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mtd_Hist_Proc_Id       : 4;   // MTD histogram surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Hdr_Ysum_Proc_Id       : 4;   // HDR ysum surface¡¯s proc_id for MXU interface.
        unsigned int Gb_Hdr_Int_Proc_Id        : 4;   // HDR LUT surface¡¯s proc_id for MXU interface.
        unsigned int Reserved_Mpid1            : 20;  // reserved
    } reg;
} Reg_Mif_Pid_1;
 
#define  Reg_Di_0_Gb_Di_Intra_Th_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Di_0_Gb_Di_Isfeather_Th_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Di_0_Gb_Di_Force_Eela_Th_BitField_MaxValue ((1u << 18) - 1)
#define  Reg_Di_0_Reserved_Di0_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Intra_Th            : 6;   // A coefficient for intra_diff calculation
        unsigned int Gb_Di_Isfeather_Th        : 7;   // Compared with diff between two lines 
        unsigned int Gb_Di_Force_Eela_Th       : 18;  // Compared with weighted sum value a to judge if force to do
                                                      // EELA ?
        unsigned int Reserved_Di0              : 1;   // reserved
    } reg;
} Reg_Di_0;
 
#define  Reg_Di_1_Gb_Di_Scroll_Th_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Di_1_Gb_Point_Degree_Var_K_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Di_1_Reserved_Di1_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Scroll_Th           : 20;  // Compared with scoll_diff to judge if need to do scroll
                                                      // refinement
        unsigned int Gb_Point_Degree_Var_K     : 8;   // Parameters for calculating the sectioned function, the
                                                      // result EDGE_TH is used to judge if the current point is an
                                                      // edge point in this area
        unsigned int Reserved_Di1              : 4;   // reserved
    } reg;
} Reg_Di_1;
 
#define  Reg_Di_2_Gb_Sobel_Th_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Di_2_Gb_Sobel_Force_Value_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Di_2_Gb_Di_Feather_Edge_Cnt_X1_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Di_2_Gb_Di_Feather_Edge_Cnt_Y1_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Di_2_Reserved_Di2_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sobel_Th               : 7;   // Compared with sobel_diff to judge if current point is on
                                                      // the narrow line
        unsigned int Gb_Sobel_Force_Value      : 9;   // Fix the xx and yy to this value if current point is on the
                                                      // narrow line
        unsigned int Gb_Di_Feather_Edge_Cnt_X1 : 6;   // Parameters for calculating the sectioned function, the
                                                      // result CNT_TH  is used to judge if the area contains feather
                                                      // lines
        unsigned int Gb_Di_Feather_Edge_Cnt_Y1 : 4;   // Parameters for calculating the sectioned function, the
                                                      // result CNT_TH  is used to judge if the area contains feather
                                                      // lines
        unsigned int Reserved_Di2              : 6;   // reserved
    } reg;
} Reg_Di_2;
 
#define  Reg_Di_3_Gb_Di_Iad_Md_X1_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Di_3_Gb_Di_Iad_Md_X2_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Iad_Md_X1           : 16;  // Parameters for calculating the sectioned function, the
                                                      // result is VAR_TH is used to judge if the line is smooth
        unsigned int Gb_Di_Iad_Md_X2           : 16;  // Parameters for calculating the sectioned function, the
                                                      // result is VAR_TH is used to judge if the line is smooth
    } reg;
} Reg_Di_3;
 
#define  Reg_Di_4_Gb_Di_Iad_Md_Y1_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Di_4_Gb_Di_Iad_Md_K_BitField_MaxValue ((1u << 12) - 1)
#define  Reg_Di_4_Reserved_Di4_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Iad_Md_Y1           : 15;  // Parameters for calculating the sectioned function, the
                                                      // result is VAR_TH is used to judge if the line is smooth
        unsigned int Gb_Di_Iad_Md_K            : 12;  // Parameters for calculating the sectioned function, the
                                                      // result is VAR_TH is used to judge if the line is smooth
        unsigned int Reserved_Di4              : 5;   // reserved
    } reg;
} Reg_Di_4;
 
#define  Reg_Di_5_Gb_Point_Degree_Var_X1_BitField_MaxValue ((1u << 12) - 1)
#define  Reg_Di_5_Gb_Point_Degree_Var_X2_BitField_MaxValue ((1u << 12) - 1)
#define  Reg_Di_5_Gb_Point_Degree_Var_Y1_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Point_Degree_Var_X1    : 12;  // Parameters for calculating the sectioned function, the
                                                      // result EDGE_TH is used to judge if the current point is an
                                                      // edge point in this area
        unsigned int Gb_Point_Degree_Var_X2    : 12;  // Parameters for calculating the sectioned function, the
                                                      // result EDGE_TH is used to judge if the current point is an
                                                      // edge point in this area
        unsigned int Gb_Point_Degree_Var_Y1    : 8;   // Parameters for calculating the sectioned function, the
                                                      // result EDGE_TH is used to judge if the current point is an
                                                      // edge point in this area
    } reg;
} Reg_Di_5;
 
#define  Reg_Di_6_Gb_Top_Bot_Field_Div_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Di_6_Gb_Di_Enable_Staticflag_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Di_6_Gb_Di_Feather_Edge_Cnt_K_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Di_6_Gb_Di_Feather_Edge_Cnt_X2_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Di_6_Gb_Fd_Wait_Frame_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Di_6_Reserved_Di6_BitField_MaxValue ((1u << 7) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Top_Bot_Field_Div      : 1;   // Indicate top/bottom field not packed into one frame if the
                                                      // value of this register is 1 .
        unsigned int Gb_Di_Enable_Staticflag   : 1;   // Enable static judgement for DI MTD
        unsigned int Gb_Di_Feather_Edge_Cnt_K : 7;    // Parameters for calculating the sectioned function, the
                                                      // result CNT_TH  is used to judge if the area contains feather
                                                      // lines
        unsigned int Gb_Di_Feather_Edge_Cnt_X2 : 6;   // Parameters for calculating the sectioned function, the
                                                      // result CNT_TH  is used to judge if the area contains feather
                                                      // lines
        unsigned int Gb_Fd_Wait_Frame          : 10;  // Enter FD after these wait frames. This register will
                                                      // restrict FD enter condition.
        unsigned int Reserved_Di6              : 7;   // reserved
    } reg;
} Reg_Di_6;
 
#define  Reg_Di_7_Gb_Edge_Flag_Th_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Di_7_Gb_Di_Intra_Diff_Th_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Di_7_Reserved_Di7_BitField_MaxValue ((1u << 3) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Edge_Flag_Th           : 9;   // Compared with Edge_max to judge if current point is Edge
                                                      // point
        unsigned int Gb_Di_Intra_Diff_Th       : 20;  // Compared with intra_diff to judge if the current point is
                                                      // intra-frame-motion case
        unsigned int Reserved_Di7              : 3;   // reserved
    } reg;
} Reg_Di_7;
 
#define  Reg_Di_8_Gb_Use_Mv_Judge_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Di_8_Gb_Use_Allmv_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Di_8_Gb_Mv_Diff_Th_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Di_8_Gb_Direction_Judge_Th_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Di_8_Gb_Fd_Bad_Merge_Th_1_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Di_8_Gb_Fd_Bad_Merge_Th_2_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Di_8_Reserved_Di8_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Use_Mv_Judge           : 1;   // flag to indicate if use mv judge for scroll line
        unsigned int Gb_Use_Allmv              : 1;   // Flag to indicate if use all the mv (from 0 to 19) judge for
                                                      // scroll line
        unsigned int Gb_Mv_Diff_Th             : 5;   // Compare difference between mv of MTD and current pixel
                                                      // with this threshold
        unsigned int Gb_Direction_Judge_Th     : 7;   // Compare sobel results with this threshold
        unsigned int Gb_Fd_Bad_Merge_Th_1      : 9;   // FD bad merge th.
                                                      //  Bad merge condition 1: must got enough different pixels
        unsigned int Gb_Fd_Bad_Merge_Th_2      : 4;   // FD bad merge th.
                                                      //  Bad merge condition 2: field counter 2 and 3 have bad
                                                      // relationship.
        unsigned int Reserved_Di8              : 5;   // reserved
    } reg;
} Reg_Di_8;
 
#define  Reg_Di_9_Gb_Di_Md_Area_Th0_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Di_9_Gb_Di_Md_Area_Th1_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Md_Area_Th0         : 16;  // DI motion detect threshold for motion value adjust in area
                                                      // difference compare.
        unsigned int Gb_Di_Md_Area_Th1         : 16;  // DI motion detect threshold for motion value adjust in
                                                      // fading difference compare.
    } reg;
} Reg_Di_9;
 
#define  Reg_Di_A_Gb_Di_Md_Area_Coef0_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Di_A_Gb_Di_Md_Area_Coef1_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Di_A_Gb_Di_Md_Adj_Coef0_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Di_A_Gb_Di_Md_Adj_Coef1_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Di_A_Reserved_Dia_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Md_Area_Coef0       : 5;   // DI motion detect coefficient for motion value adjust in
                                                      // fading difference compare.
        unsigned int Gb_Di_Md_Area_Coef1       : 5;   // DI motion detect coefficient for motion value adjust.
        unsigned int Gb_Di_Md_Adj_Coef0        : 8;   // DI motion value adjust high coefficient based on motion
                                                      // detect threshold.
        unsigned int Gb_Di_Md_Adj_Coef1        : 8;   // DI motion value adjust low coefficient based on motion
                                                      // detect threshold.
        unsigned int Reserved_Dia              : 6;   // reserved
    } reg;
} Reg_Di_A;
 
#define  Reg_Di_B_Gb_Di_Iad_Ave_Adj_Th0_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Di_B_Gb_Di_Iad_Ave_Adj_Th1_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Di_B_Reserved_Dib_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Iad_Ave_Adj_Th0     : 10;  // DI IAD high threshold for ave threshold adjust.
        unsigned int Gb_Di_Iad_Ave_Adj_Th1     : 10;  // DI IAD low threshold for ave threshold adjust.
        unsigned int Reserved_Dib              : 12;  // reserved
    } reg;
} Reg_Di_B;
 
#define  Reg_Di_C_Gb_Di_Iad_Ave_Adj_Val_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Di_C_Gb_Di_Iad_Ave_Adj_Coef_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Di_C_Gb_Di_Mtd_Featherdetect_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Di_C_Reserved_Dic_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Iad_Ave_Adj_Val     : 14;  // DI IAD threshold adjust value.
        unsigned int Gb_Di_Iad_Ave_Adj_Coef    : 5;   // DI IAD coefficient for ave threshold adjust.
        unsigned int Gb_Di_Mtd_Featherdetect_En : 1;  // Enable feather detect algorithm in MTD part
        unsigned int Reserved_Dic              : 12;  // reserved
    } reg;
} Reg_Di_C;
 
#define  Reg_Di_D_Gb_Di_Iad_Line_Md_X1_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Di_D_Gb_Di_Iad_Line_Md_X2_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Iad_Line_Md_X1      : 16;  // Used for calculate xline_th which is used for iadetect
        unsigned int Gb_Di_Iad_Line_Md_X2      : 16;  // Used for calculate xline_th which is used for iadetect
    } reg;
} Reg_Di_D;
 
#define  Reg_Di_E_Gb_Di_Mtd_Featherpara_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Di_E_Gb_Di_Iad_Line_Md_Y1_BitField_MaxValue ((1u << 15) - 1)
#define  Reg_Di_E_Gb_Di_Iad_Line_Md_K_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Mtd_Featherpara     : 5;   // Used to Judge if scroll mv will introduce feather
        unsigned int Gb_Di_Iad_Line_Md_Y1      : 15;  // Used for calculate xline_th which is used for iadetect
        unsigned int Gb_Di_Iad_Line_Md_K       : 12;  // Used for calculate xline_th which is used for iadetect
    } reg;
} Reg_Di_E;
 
#define  Reg_Vpp_Control_0_Gb_Di_Th_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Vpp_Control_0_Reserved_Vc01_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Vpp_Control_0_Gb_Md_Th2_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Control_0_Gb_Md_Th2_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Vpp_Control_0_Reserved_Vc0_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Th                  : 8;   // DeInterlace MAD threshold
        unsigned int Reserved_Vc01             : 2;   // reserved
        unsigned int Gb_Md_Th2                 : 5;   // motion detection threshold for DI_ALU
        unsigned int Gb_Md_Th2_En              : 1;   // Enable DM_th2 check
        unsigned int Reserved_Vc0              : 16;  // reserved
    } reg;
} Reg_Vpp_Control_0;
 
#define  Reg_Vpp_Control_3_Gb_Md_Th_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Vpp_Control_3_Gb_Di_Sr_Rev_Diff_Th_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Control_3_Reserved_Vc3_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Md_Th                  : 20;  // motion detection used threshold
        unsigned int Gb_Di_Sr_Rev_Diff_Th      : 10;  // Threshold of SR revise difference threshold
        unsigned int Reserved_Vc3              : 2;   // reserved
    } reg;
} Reg_Vpp_Control_3;
 
#define  Reg_Vpp_Control_4_Gb_Di_Mtd_Edgevalthr_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Control_4_Gb_Di_Mtd_Staticpara_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Control_4_Gb_Di_Mtd_Maxminthr_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Vpp_Control_4_Gb_Di_Sr_Grad_Th_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Control_4_Gb_Di_Mtd_Md_Th_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Vpp_Control_4_Reserved_Vc4_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Mtd_Edgevalthr      : 5;   // Threshold of edge pixel
        unsigned int Gb_Di_Mtd_Staticpara      : 5;   // Judgment parameter for static stripe
        unsigned int Gb_Di_Mtd_Maxminthr       : 3;   // Threshold of max/min histdif
        unsigned int Gb_Di_Sr_Grad_Th          : 10;  // Threshold of SR gradient judge
        unsigned int Gb_Di_Mtd_Md_Th           : 7;   // Threshold of MTD motion detection.
        unsigned int Reserved_Vc4              : 2;   // reserved
    } reg;
} Reg_Vpp_Control_4;
 
#define  Reg_Vpp_Control_5_Gb_Di_Sr_Line_Diff_Th_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Control_5_Gb_Di_Iad_Md_Ave_Th_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Control_5_Reserved_Vc12_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Sr_Line_Diff_Th     : 10;  // Threshold of difference of up line and below line
        unsigned int Gb_Di_Iad_Md_Ave_Th       : 10;  // Threshold of average of md value
        unsigned int Reserved_Vc12             : 12;  // reserved
    } reg;
} Reg_Vpp_Control_5;
 
#define  Reg_Vpp_Control_6_Gb_Mtd_Col_Hist_Base_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Mtd_Col_Hist_Base      : 32;  // the base to store each stream MTD column histgram, 2k bit
                                                      // aligned (the size should be bigger than 1366*4/8 = 683 * 2K)
    } reg;
} Reg_Vpp_Control_6;
 
#define  Reg_Vpp_Control_9_Gb_Md_Low_Th_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Vpp_Control_9_Reserved_Vc9_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Md_Low_Th              : 20;  // threshhold for low level md
        unsigned int Reserved_Vc9              : 12;  // reserved
    } reg;
} Reg_Vpp_Control_9;
 
#define  Reg_Vpp_Lbuf_0_Gb_Lbuf_Size_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Vpp_Lbuf_0_Gb_Vpp_In_Size_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Vpp_Lbuf_0_Gb_Disable_Lcid_Blend_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Vpp_Lbuf_0_Gb_Fd_Force_Di_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Vpp_Lbuf_0_Gb_Di_Blend_Coef_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Vpp_Lbuf_0_Reserved_Vl0_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Lbuf_Size              : 14;  // line buffer size
        unsigned int Gb_Vpp_In_Size            : 11;  // Input Stage Y channel line buffer size, the total lb size =
                                                      // Vpp_In_Size *2 (422) or Vpp_In_Size *1.5 (420)
        unsigned int Gb_Disable_Lcid_Blend     : 1;   // DI will not enter blending case
        unsigned int Gb_Fd_Force_Di            : 1;   // FD enable, result will be forced into DI mode
        unsigned int Gb_Di_Blend_Coef          : 3;   // DI blend coef
        unsigned int Reserved_Vl0              : 2;   // reserved
    } reg;
} Reg_Vpp_Lbuf_0;
 
#define  Reg_Vpp_Lbuf_1_Gb_Vpp_Di_Offset_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Lbuf_1_Gb_Vpp_Di_Size_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Lbuf_1_Gb_Vpp_Diref_In_Offset_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Lbuf_1_Reserved_Vl1_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Vpp_Di_Offset          : 10;  // DI linebuffer start offset
        unsigned int Gb_Vpp_Di_Size            : 10;  // DI Y Channel linebuffer size, 
                                                      //  the total LB size = Vpp_DI_Size*2 (422) or Vpp_DI_Size
                                                      // *1.5 (420)
        unsigned int Gb_Vpp_Diref_In_Offset    : 10;  // lbuf offset for input di reference surface, size is same as
                                                      // gb_vpp_in_size
        unsigned int Reserved_Vl1              : 2;   // Reserved
    } reg;
} Reg_Vpp_Lbuf_1;
 
#define  Reg_Vpp_Fd_Control_0_Gb_Fd_Md_Th_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Vpp_Fd_Control_0_Gb_Scene_Change_Top_BitField_MaxValue ((1u << 12) - 1)
#define  Reg_Vpp_Fd_Control_0_Gb_Scene_Change_Bottom_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fd_Md_Th               : 8;   // fd motion threshold
        unsigned int Gb_Scene_Change_Top       : 12;  // scene change detect top edge
        unsigned int Gb_Scene_Change_Bottom    : 12;  // scene change detect bottom edge
    } reg;
} Reg_Vpp_Fd_Control_0;
 
#define  Reg_Vpp_Fd_Control_1_Gb_2v2_Th_Delta_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Vpp_Fd_Control_1_Gb_2v2_Th_Ratio_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_1_Gb_2v2_Sad_Counter_Th_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Fd_Control_1_Gb_2v2_Md_Failed_Counter_Th_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_1_Gb_Lcid_Diff_Th_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Vpp_Fd_Control_1_Gb_2v2_Count_Mode_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_2v2_Th_Delta           : 8;   // 2v2 filter's delta value
        unsigned int Gb_2v2_Th_Ratio           : 4;   // 2v2 filter's ratio
        unsigned int Gb_2v2_Sad_Counter_Th     : 5;   // 2v2 sad detect compare threshold
        unsigned int Gb_2v2_Md_Failed_Counter_Th : 4; // MD 2v2 failed counter threshold
        unsigned int Gb_Lcid_Diff_Th           : 10;  // threshold for diff with lcid
        unsigned int Gb_2v2_Count_Mode         : 1;   // 2v2 counter count mode when Enter FD mode                                                                                              0: keep the
                                                      // current value (no update after entry FD mode)                                                                                              1: go on
                                                      // counting even if entry FD mode
    } reg;
} Reg_Vpp_Fd_Control_1;
 
#define  Reg_Vpp_Fd_Control_2_Gb_Scene_Change_Th_BitField_MaxValue ((1u << 23) - 1)
#define  Reg_Vpp_Fd_Control_2_Gb_Scenechange_Md_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Vpp_Fd_Control_2_Gb_Fd_Md_Th2_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Scene_Change_Th        : 23;  // scene change threshold for (4k*2k)
        unsigned int Gb_Scenechange_Md_Mode    : 1;   // When scene change happens, MD compute mode 
        unsigned int Gb_Fd_Md_Th2              : 8;   // fd motion threshold2
    } reg;
} Reg_Vpp_Fd_Control_2;
 
#define  Reg_Vpp_Fd_Control_3_Gb_Fd_Counter_Th_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_Fd_Detect_Counter_Initial_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_Fd_Strong_Counter_Initial_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_2v2_Failed_Counter_Th_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_2v2_Md_Succeed_Counter_Th_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_2v2_Sad_Succeed_Counter_Th_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Fd_Control_3_Gb_2v2_Sad_Failed_Range_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fd_Counter_Th          : 4;   // fd counter threshold
        unsigned int Gb_Fd_Detect_Counter_Initial : 4;// the initial value for fd detect counter
        unsigned int Gb_Fd_Strong_Counter_Initial : 4;// the initial value for fd judge counter
        unsigned int Gb_2v2_Failed_Counter_Th : 5;    // the counter threshold for 2v2 force failed case
        unsigned int Gb_2v2_Md_Succeed_Counter_Th : 5;// the counter threshold for 2v2 judged by motion
        unsigned int Gb_2v2_Sad_Succeed_Counter_Th : 5;
                                                      // the counter threshold for 2v2 judged by sad
        unsigned int Gb_2v2_Sad_Failed_Range   : 5;   // SAD 2v2 failed range delta
    } reg;
} Reg_Vpp_Fd_Control_3;
 
#define  Reg_Vpp_Fd_Control_4_Gb_2v2_Frame_Cnt_Th_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_4_Gb_2v2_Failed_Counter_Th2_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Vpp_Fd_Control_4_Gb_Fd_2v2_Sad_Clr_Th_1_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_4_Gb_Fd_2v2_Sad_Clr_Th_2_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_4_Gb_Fd_2v2_Sad_Clr_Th_3_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_4_Reserved_Fd4_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_2v2_Frame_Cnt_Th       : 9;   // thresh hold for 2v2 failed counter switch
        unsigned int Gb_2v2_Failed_Counter_Th2 : 5;   // 2nd threshold for 2v2 failed counter
        unsigned int Gb_Fd_2v2_Sad_Clr_Th_1    : 9;   // For 2v2 sad flag clear use. Inter-frame big motion
                                                      // threshold.
        unsigned int Gb_Fd_2v2_Sad_Clr_Th_2    : 4;   // For 2v2 sad flag clear use. Inter-frame difference
                                                      // threshold 1.
        unsigned int Gb_Fd_2v2_Sad_Clr_Th_3    : 4;   // For 2v2 sad flag clear use. Inter-frame difference
                                                      // threshold 2.
        unsigned int Reserved_Fd4              : 1;   // reserved
    } reg;
} Reg_Vpp_Fd_Control_4;
 
#define  Reg_Vpp_Fd_Control_5_Gb_Fd_Bad_Copy_Th_1_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Vpp_Fd_Control_5_Gb_Fd_Bad_Copy_Th_2_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_5_Gb_Fd_Bad_Copy_Th_3_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Vpp_Fd_Control_5_Gb_Fd_Bad_Copy_Th_4_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Vpp_Fd_Control_5_Gb_Fd_Quit_2v2_Th_1_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_5_Reserved_Fd5_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fd_Bad_Copy_Th_1       : 7;   // For bad copy use. Max pixels in FD copy mode.
        unsigned int Gb_Fd_Bad_Copy_Th_2       : 9;   // For bad copy use. Inter-frame motion pixels threshold.
        unsigned int Gb_Fd_Bad_Copy_Th_3       : 3;   // For bad copy use. Inter-frame motion difference
                                                      // threshold 1.
        unsigned int Gb_Fd_Bad_Copy_Th_4       : 3;   // For bad copy use. Inter-frame motion difference
                                                      // threshold 2.
        unsigned int Gb_Fd_Quit_2v2_Th_1       : 9;   // For quit 2v2 use. 2v2 inter-frame motion threshold.
        unsigned int Reserved_Fd5              : 1;   // reserved
    } reg;
} Reg_Vpp_Fd_Control_5;
 
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_Quit_2v2_Th_2_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_Quit_2v2_Th_3_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_Quit_2v2_Th_4_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_Quit_2v2_Th_5_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_2v2_Md_Th_3_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_Vpp_Fd_Control_6_Gb_Fd_2v2_Md_Th_5_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fd_Quit_2v2_Th_2       : 4;   // For quit 2v2 use. 2v2 inter-frame motion and intra-frame
                                                      // motion difference threshold 1.
        unsigned int Gb_Fd_Quit_2v2_Th_3       : 7;   // For quit 2v2 use. Old 2v2 md counters fail threshold.
        unsigned int Gb_Fd_Quit_2v2_Th_4       : 9;   // For quit 2v2 use. Motion judge based on new counters.
        unsigned int Gb_Fd_Quit_2v2_Th_5       : 4;   // For quit 2v2 use. 2v2 inter-frame motion and intra-frame
                                                      // motion difference threshold 2.
        unsigned int Gb_Fd_2v2_Md_Th_3         : 4;   // For 2v2 detect use. Big motion difference threshold.
        unsigned int Gb_Fd_2v2_Md_Th_5         : 4;   // For 2v2 detect use. Small motion difference threshold.
    } reg;
} Reg_Vpp_Fd_Control_6;
 
#define  Reg_Vpp_Fd_Control_7_Gb_Fd_2v2_Md_Th_1_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_7_Gb_Fd_2v2_Md_Th_2_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Vpp_Fd_Control_7_Gb_Fd_2v2_Md_Th_4_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Vpp_Fd_Control_7_Gb_Fd_Sc_Quit_2v2_Th_BitField_MaxValue ((1u << 3) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Fd_2v2_Md_Th_1         : 9;   // For 2v2 detect use. Small motion threshold.
        unsigned int Gb_Fd_2v2_Md_Th_2         : 11;  // For 2v2 detect use. Big motion threshold.
        unsigned int Gb_Fd_2v2_Md_Th_4         : 9;   // For 2v2 detect use. Intra-frame small motion threshold.
        unsigned int Gb_Fd_Sc_Quit_2v2_Th      : 3;   // For sc quit 2v2 use. Top filed and bottom filed difference
                                                      // threshold.
    } reg;
} Reg_Vpp_Fd_Control_7;
 
#define  Reg_Cg_Ctrl_Gb_Di_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Scl_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Scl_Bp_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Cscb_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Cscf_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Cg_Busy_Th_BitField_MaxValue ((1u << 3) - 1)
#define  Reg_Cg_Ctrl_Gb_Fire_After_Save_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Restore_Keep_On_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_For_Eco2_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Cg_Ctrl_Gb_Cpt_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Sr_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Cm_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Ccm_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Gb_Hdr_Cg_Off_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cg_Ctrl_Reserved_Cg_BitField_MaxValue ((1u << 9) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_Cg_Off              : 1;   // turn off DI clock gating function
        unsigned int Gb_Scl_Cg_Off             : 1;   // turn off SCL clock gating function
        unsigned int Gb_Scl_Bp_Cg_Off          : 1;   // turn off SCL bypass logic clock gating function
        unsigned int Gb_Cscb_Cg_Off            : 1;   // turn off CSCB clock gating function
        unsigned int Gb_Cscf_Cg_Off            : 1;   // turn off CSCF clock gating function
        unsigned int Gb_Cg_Busy_Th             : 3;   // VPP_BUSY counter thereshold, to prevent the case that
                                                      // VPP_BUSY has abnormal deassert
        unsigned int Gb_Fire_After_Save        : 1;   // current fire doesn't check save result, so when fire, save
                                                      // is still ongoing; here is a backdoor to prevent that under
                                                      // some cases that when DI/DNS change stream result, save
                                                      // still not finished; then we can let fire to wait save_ok
        unsigned int Gb_Restore_Keep_On        : 1;   // backdoor for restore, enable it to make restore work
                                                      // before every frame
        unsigned int Gb_For_Eco2               : 8;   // reserved for possible ECO use
        unsigned int Gb_Cpt_Cg_Off             : 1;   // turn off CPT clock gating function
        unsigned int Gb_Sr_Cg_Off              : 1;   // turn off SR clock gating function
        unsigned int Gb_Cm_Cg_Off              : 1;   // turn off CM clock gating function
        unsigned int Gb_Ccm_Cg_Off             : 1;   // turn off CCM clock gating function
        unsigned int Gb_Hdr_Cg_Off             : 1;   // turn off HDR clock gating function
        unsigned int Reserved_Cg               : 9;   // reserved
    } reg;
} Reg_Cg_Ctrl;
 
#define  Reg_From_Opcode_Gb_Di_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Fd_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Mtd_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Two_Frame_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Di_Force_Lcid_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Single_Sel_Oth_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Top_Field_First_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Reset_Hqvpp_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Hqvpp_Mode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_From_Opcode_Gb_Vpp_Fd_Index_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_From_Opcode_Reserved_Opcode_BitField_MaxValue ((1u << 21) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Di_En                  : 1;   // DI enable
        unsigned int Gb_Fd_En                  : 1;   // FD enable
        unsigned int Gb_Mtd_En                 : 1;   // MTD enable
        unsigned int Gb_Two_Frame_Out_En       : 1;   // 0: VPP 1 frame out mode
                                                      //  1: VPP 2 frame out mode
        unsigned int Gb_Di_Force_Lcid          : 1;   // 0: normal DI flow
                                                      //  1: force to do LCID for all pixels
        unsigned int Gb_Single_Sel_Oth         : 1;   // select the source of DI output when gb_two_frame_out_en =
                                                      // 0
                                                      //  0: output from DI current surface alu
                                                      //  1: output from DI other surface alu
        unsigned int Gb_Top_Field_First        : 1;   // 0: bottom field is first
                                                      //  1: top field is first
                                                      //  used by VPP FilmDetect/de-interlace.
        unsigned int Gb_Reset_Hqvpp            : 1;   // HQVPP reset control. When first frame in one stream, set
                                                      // gb_reset_hqvpp = 1
        unsigned int Gb_Hqvpp_Mode             : 1;   // 0: Basic VPP mode
                                                      //  1: HQVPP mode
        unsigned int Gb_Vpp_Fd_Index           : 2;   // index of fd parameters
        unsigned int Reserved_Opcode           : 21;  // reserved
    } reg;
} Reg_From_Opcode;
 
#define  Reg_Cm_0_Gb_Cmlut_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cm_0_Gb_Tint_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Cm_0_Gb_Tint_Hoffset_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Cm_0_Reserved_Cm0_BitField_MaxValue ((1u << 20) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cmlut_En               : 1;   // cm lut enable
        unsigned int Gb_Tint_En                : 1;   // tine enable
        unsigned int Gb_Tint_Hoffset           : 10;  // tint h offset
        unsigned int Reserved_Cm0              : 20;  // reserved
    } reg;
} Reg_Cm_0;
 
#define  Reg_Cm_1_Gb_Cmlut0_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Cm_1_Gb_Cmlut1_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Cm_1_Reserved_Cm1_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Cmlut0                 : 11;  // cm value look up table 0 ~ 40
        unsigned int Gb_Cmlut1                 : 11;  // cm value look up table 41 ~ 80
        unsigned int Reserved_Cm1              : 10;  // reserved
    } reg;
} Reg_Cm_1;
 
#define  Reg_Ccm_0_Gb_Ccm_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Ccm_0_Gb_Metadata_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Ccm_0_Gb_Dg_Hcoe_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Ccm_0_Reserved_Ccm0_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Ccm_En                 : 1;   // 0:  conversion disable(don't do degamma,conversion and
                                                      // gamma);      
                                                      //  1: conversion enable(do degamma,conversion and gamma)
        unsigned int Gb_Metadata_En            : 1;   // 0:  don't support metadata, need static max and min value;  
                                                      //  1:  support metadata, don't need static
        unsigned int Gb_Dg_Hcoe                : 20;  // degamma high coefficient
        unsigned int Reserved_Ccm0             : 10;  // reserved
    } reg;
} Reg_Ccm_0;
 
#define  Reg_Ccm_1_Gb_Dg_Lcoe_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Ccm_1_Gb_Yuv2rgb_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Ccm_1_Gb_Yuv2rgb_Mode_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Ccm_1_Gb_Ccm_Hdr_Inv_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Ccm_1_Reserved_Ccm1_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dg_Lcoe                : 20;  // degamma low coefficient
        unsigned int Gb_Yuv2rgb_En             : 1;   // YUV to RGB enable
        unsigned int Gb_Yuv2rgb_Mode           : 2;   // Select YUV2RGB matrix mode:
                                                      //  00: 601->rgb
                                                      //  01: 709->rgb
                                                      //  10: 2020->rgb
        unsigned int Gb_Ccm_Hdr_Inv            : 1;   // If enable, invert CCM->HDR to HDR->CCM
        unsigned int Reserved_Ccm1             : 8;   // reserved
    } reg;
} Reg_Ccm_1;
 
#define  Reg_Ccm_3_Gb_Dg_Tbl_0_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_3_Gb_Dg_Tbl_1_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Dg_Tbl_0               : 16;  // digamma table's item: gb_dg_tbl_00 ~ gb_dg_tbl_0f
        unsigned int Gb_Dg_Tbl_1               : 16;  // digamma table's item: gb_dg_tbl_10 ~ gb_dg_tbl_1f
    } reg;
} Reg_Ccm_3;
 
#define  Reg_Ccm_4_Gb_G_Tbl_0_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Ccm_4_Gb_G_Tbl_1_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Ccm_4_Gb_G_Tbl_2_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Ccm_4_Reserved_Ccm5_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_G_Tbl_0                : 10;  // gamma table's item: gb_g_tbl_00 ~ gb_g_tbl_0f
        unsigned int Gb_G_Tbl_1                : 10;  // gamma table's item: gb_g_tbl_10 ~ gb_g_tbl_1f
        unsigned int Gb_G_Tbl_2                : 10;  // gamma table's item: gb_g_tbl_20 ~ gb_g_tbl_2f
        unsigned int Reserved_Ccm5             : 2;   // reserved
    } reg;
} Reg_Ccm_4;
 
#define  Reg_Ccm_5_Gb_Hlg_En_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Ccm_5_Gb_Hlg_Acoef_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_5_Gb_Hlg_Bcoef_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Ccm_5_Reserved_Ccm6_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_En                 : 2;   // 00: HLG disable
                                                      //  01: HLG enable do HLG EOTF
                                                      //  10: HLG enable do HLG inv(EOTF)
                                                      //  11: HLG enable do HLG EOTF and inv(EOTF)
        unsigned int Gb_Hlg_Acoef              : 16;  // Fx10.6(16 bit) HLG OOTF coefficient A
        unsigned int Gb_Hlg_Bcoef              : 10;  // Fx10.0(10 bit) HLG OOTF coefficient B
        unsigned int Reserved_Ccm6             : 4;   // reserved
    } reg;
} Reg_Ccm_5;
 
#define  Reg_Ccm_6_Gb_Hlg_Tbl_0_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_6_Gb_Hlg_Tbl_1_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Tbl_0              : 16;  // Fx10.6 HLG OOTF Table's 0 ~ 15
        unsigned int Gb_Hlg_Tbl_1              : 16;  // Fx10.6 HLG OOTF Table's 16 ~ 31
    } reg;
} Reg_Ccm_6;
 
#define  Reg_Ccm_7_Gb_Hlg_Tbl_20_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_7_Gb_Hlg_Tbl_21_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Tbl_20             : 16;  // Fx10.6 HLG OOTF Table's 32
        unsigned int Gb_Hlg_Tbl_21             : 16;  // Fx10.6 HLG OOTF Table's 33
    } reg;
} Reg_Ccm_7;
 
#define  Reg_Ccm_8_Gb_Hlg_Tbl_22_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_8_Gb_Hlg_Invtbl_22_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Tbl_22             : 16;  // Fx10.6 HLG OOTF Table's 34
        unsigned int Gb_Hlg_Invtbl_22          : 16;  // Fx10.6 HLG  inverse OOTF Table's 34
    } reg;
} Reg_Ccm_8;
 
#define  Reg_Ccm_9_Gb_1886_Acoef_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_9_Gb_1886_Bcoef_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_1886_Acoef             : 16;  // Fx10.6(16 bit) 1886 EOTF coefficient A
        unsigned int Gb_1886_Bcoef             : 16;  // Fx10.6(16 bit) 1886 EOTF coefficient B
    } reg;
} Reg_Ccm_9;
 
#define  Reg_Ccm_A_Gb_Hlg_Invacoef_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_A_Gb_Hlg_Invbcoef_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Ccm_A_Gb_1886_En_BitField_MaxValue ((1u << 2) - 1)
#define  Reg_Ccm_A_Reserved_Ccm9_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Invacoef           : 16;  // Fx6.10(16 bit) HLG inverse OOTF coefficient A
        unsigned int Gb_Hlg_Invbcoef           : 10;  // Fx10.0(10 bit) HLG inverse OOTF coefficient B
        unsigned int Gb_1886_En                : 2;   // 00: 1886 disable
                                                      //  01:  1886 enable do EOTF
                                                      //  10: 1886 enable do inv(EOTF)
                                                      //  11: 1886 enable do EOTF and inv(EOTF)
        unsigned int Reserved_Ccm9             : 4;   // reserved
    } reg;
} Reg_Ccm_A;
 
#define  Reg_Ccm_B_Gb_Hlg_Invtbl_0_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_B_Gb_Hlg_Invtbl_1_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Invtbl_0           : 16;  // Fx10.6 HLG  inverse OOTF Table's 0 ~ 15
        unsigned int Gb_Hlg_Invtbl_1           : 16;  // Fx10.6 HLG  inverse OOTF Table's 16 ~ 31
    } reg;
} Reg_Ccm_B;
 
#define  Reg_Ccm_C_Gb_Hlg_Invtbl_20_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_C_Gb_Hlg_Invtbl_21_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hlg_Invtbl_20          : 16;  // Fx10.6 HLG inverse OOTF Table's 32
        unsigned int Gb_Hlg_Invtbl_21          : 16;  // Fx10.6 HLG  inverse OOTF Table's 33
    } reg;
} Reg_Ccm_C;
 
#define  Reg_Ccm_D_Gb_1886_Invacoef_BitField_MaxValue ((1u << 16) - 1)
#define  Reg_Ccm_D_Gb_1886_Invbcoef_BitField_MaxValue ((1u << 16) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_1886_Invacoef          : 16;  // Fx6.10(16 bit) 1886 inverse EOTF coefficient A
        unsigned int Gb_1886_Invbcoef          : 16;  // Fx10.6(16 bit) 1886 inverse EOTF coefficient B
    } reg;
} Reg_Ccm_D;
 
#define  Reg_Cc_0_Gb_Convert_M_00_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_0_Gb_Convert_M_01_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_0_Reserved_Cc0_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Convert_M_00           : 14;  // color convert matrix
        unsigned int Gb_Convert_M_01           : 14;  // color convert matrix
        unsigned int Reserved_Cc0              : 4;   // reserved
    } reg;
} Reg_Cc_0;
 
#define  Reg_Cc_1_Gb_Convert_M_10_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_1_Gb_Convert_M_11_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_1_Reserved_Cc1_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Convert_M_10           : 14;  // color convert matrix
        unsigned int Gb_Convert_M_11           : 14;  // color convert matrix
        unsigned int Reserved_Cc1              : 4;   // reserved
    } reg;
} Reg_Cc_1;
 
#define  Reg_Cc_2_Gb_Convert_M_20_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_2_Gb_Convert_M_21_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_2_Reserved_Cc2_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Convert_M_20           : 14;  // color convert matrix
        unsigned int Gb_Convert_M_21           : 14;  // color convert matrix
        unsigned int Reserved_Cc2              : 4;   // reserved
    } reg;
} Reg_Cc_2;
 
#define  Reg_Cc_3_Gb_Convert_M_02_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_3_Gb_Convert_M_12_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_3_Reserved_Cc3_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Convert_M_02           : 14;  // color convert matrix
        unsigned int Gb_Convert_M_12           : 14;  // color convert matrix
        unsigned int Reserved_Cc3              : 4;   // reserved
    } reg;
} Reg_Cc_3;
 
#define  Reg_Cc_4_Gb_Convert_M_22_BitField_MaxValue ((1u << 14) - 1)
#define  Reg_Cc_4_Reserved_Cc4_BitField_MaxValue ((1u << 18) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Convert_M_22           : 14;  // color convert matrix
        unsigned int Reserved_Cc4              : 18;  // reserved
    } reg;
} Reg_Cc_4;
 
#define  Reg_Hadj_0_Gb_Hadj_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hadj_0_Gb_Hrange_Gl_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_0_Gb_Hrange_Gh_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_0_Reserved_Hadj0_BitField_MaxValue ((1u << 11) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hadj_En                : 1;   // Enable Hue adjustment
        unsigned int Gb_Hrange_Gl              : 10;  // H Range_Low of G adjustment
        unsigned int Gb_Hrange_Gh              : 10;  // H Range_High of G adjustment
        unsigned int Reserved_Hadj0            : 11;  // reserved
    } reg;
} Reg_Hadj_0;
 
#define  Reg_Hadj_1_Gb_Hrange_Rl_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_1_Gb_Hrange_Rh_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_1_Reserved_Hadj1_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hrange_Rl              : 10;  // H Range_Low of R adjustment
        unsigned int Gb_Hrange_Rh              : 10;  // H Range_High of R adjustment
        unsigned int Reserved_Hadj1            : 12;  // reserved
    } reg;
} Reg_Hadj_1;
 
#define  Reg_Hadj_2_Gb_G_Range_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_2_Gb_G_Axis_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_2_Gb_G_Coef_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_G_Range                : 10;  // Range of G adjustment
        unsigned int Gb_G_Axis                 : 10;  // AXIS of G adjustment
        unsigned int Gb_G_Coef                 : 12;  // Coefficient of G adjustment
    } reg;
} Reg_Hadj_2;
 
#define  Reg_Hadj_3_Gb_R_Range_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_3_Gb_R_Axis_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hadj_3_Gb_R_Coef_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_R_Range                : 10;  // Range of R adjustment
        unsigned int Gb_R_Axis                 : 10;  // AXIS of R adjustment
        unsigned int Gb_R_Coef                 : 12;  // Coefficient of R adjustment
    } reg;
} Reg_Hadj_3;
 
#define  Reg_Sadj_0_Gb_Sadj_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Sadj_0_Gb_Sadj_Inc00_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_0_Gb_Sadj_Inc01_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_0_Reserved_Sadj0_BitField_MaxValue ((1u << 9) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_En                : 1;   // Enable Saturation adjustment
        unsigned int Gb_Sadj_Inc00             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc01             : 11;  // The value of Increment
        unsigned int Reserved_Sadj0            : 9;   // reserved
    } reg;
} Reg_Sadj_0;
 
#define  Reg_Sadj_1_Gb_Sadj_Inc02_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_1_Gb_Sadj_Inc03_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_1_Reserved_Sadj1_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc02             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc03             : 11;  // The value of Increment
        unsigned int Reserved_Sadj1            : 10;  // reserved
    } reg;
} Reg_Sadj_1;
 
#define  Reg_Sadj_2_Gb_Sadj_Inc04_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_2_Gb_Sadj_Inc05_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_2_Reserved_Sadj2_BitField_MaxValue ((1u << 10) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc04             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc05             : 11;  // The value of Increment
        unsigned int Reserved_Sadj2            : 10;  // reserved
    } reg;
} Reg_Sadj_2;
 
#define  Reg_Sadj_3_Gb_Sadj_Inc06_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_3_Gb_Sadj_Inc07_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_3_Gb_Sadj_Inc14_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Sadj_3_Reserved_Sadj3_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc06             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc07             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc14             : 5;   // The value of Increment 14, [4:0]
        unsigned int Reserved_Sadj3            : 5;   // reserved
    } reg;
} Reg_Sadj_3;
 
#define  Reg_Sadj_4_Gb_Sadj_Inc08_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_4_Gb_Sadj_Inc09_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_4_Gb_Sadj_Inc14_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Sadj_4_Reserved_Sadj4_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc08             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc09             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc14             : 6;   // The value of Increment 14, [10:5]
        unsigned int Reserved_Sadj4            : 4;   // reserved
    } reg;
} Reg_Sadj_4;
 
#define  Reg_Sadj_5_Gb_Sadj_Inc0a_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_5_Gb_Sadj_Inc0b_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_5_Gb_Sadj_Inc13_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Sadj_5_Reserved_Sadj5_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc0a             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc0b             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc13             : 5;   // The value of Increment 13, [4:0]
        unsigned int Reserved_Sadj5            : 5;   // reserved
    } reg;
} Reg_Sadj_5;
 
#define  Reg_Sadj_6_Gb_Sadj_Inc0c_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_6_Gb_Sadj_Inc0d_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_6_Gb_Sadj_Inc13_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Sadj_6_Reserved_Sadj6_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc0c             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc0d             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc13             : 6;   // The value of Increment 13, [10:5]
        unsigned int Reserved_Sadj6            : 4;   // reserved
    } reg;
} Reg_Sadj_6;
 
#define  Reg_Sadj_7_Gb_Sadj_Inc0e_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_7_Gb_Sadj_Inc0f_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_7_Gb_Sadj_Inc12_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Sadj_7_Reserved_Sadj7_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc0e             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc0f             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc12             : 5;   // The value of Increment 12, [4:0]
        unsigned int Reserved_Sadj7            : 5;   // reserved
    } reg;
} Reg_Sadj_7;
 
#define  Reg_Sadj_8_Gb_Sadj_Inc10_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_8_Gb_Sadj_Inc11_BitField_MaxValue ((1u << 11) - 1)
#define  Reg_Sadj_8_Gb_Sadj_Inc12_BitField_MaxValue ((1u << 6) - 1)
#define  Reg_Sadj_8_Reserved_Sadj8_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sadj_Inc10             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc11             : 11;  // The value of Increment
        unsigned int Gb_Sadj_Inc12             : 6;   // The value of Increment 12, [10:5]
        unsigned int Reserved_Sadj8            : 4;   // reserved
    } reg;
} Reg_Sadj_8;
 
#define  Reg_Hdr_0_Gb_Hdr_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Curve_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Cliplmt_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Maxfmean_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Maxmean_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Sc_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hdr_0_Gb_Hdr_Smallsize_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_En                 : 1;   // HDR enable
        unsigned int Gb_Hdr_Curve_En           : 1;   // HDR curve enable
        unsigned int Gb_Hdr_Cliplmt            : 10;  // Clip limit that strict the shape of mapping curve
        unsigned int Gb_Hdr_Maxfmean           : 8;   // Maximum value for fmean
        unsigned int Gb_Hdr_Maxmean            : 10;  // Maximum mean value
        unsigned int Gb_Hdr_Sc_En              : 1;   // Whether we will refer the scene change signal or not
        unsigned int Gb_Hdr_Smallsize          : 1;   // 0: not support small size, 1: support small size
    } reg;
} Reg_Hdr_0;
 
#define  Reg_Hdr_1_Gb_Hdr_Maxpeakcnt_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Hdr_1_Gb_Hdr_Minpeakwg_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Hdr_1_Gb_Hdr_Maxpeakwg_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Hdr_1_Gb_Hdr_Manualclipmode_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hdr_1_Gb_Hdr_Frmwg_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Hdr_1_Gb_Reset_Hdr_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Hdr_1_Reserved_Hdr1_BitField_MaxValue ((1u << 1) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Maxpeakcnt         : 8;   // Maximum peak counts in the histogram
        unsigned int Gb_Hdr_Minpeakwg          : 7;   // Minimum weight for feature peakCnt
        unsigned int Gb_Hdr_Maxpeakwg          : 7;   // Maximum weight for feature peakCnt
        unsigned int Gb_Hdr_Manualclipmode     : 1;   // 0: auto clip, 1: manual clip
        unsigned int Gb_Hdr_Frmwg              : 7;   // Weight of previous frame for inter-frame filtering
        unsigned int Gb_Reset_Hdr              : 1;   // Reset signal of hdr
        unsigned int Reserved_Hdr1             : 1;   // reserved
    } reg;
} Reg_Hdr_1;
 
#define  Reg_Hdr_2_Gb_Hdr_Pixcntforstat_BitField_MaxValue ((1u << 27) - 1)
#define  Reg_Hdr_2_Gb_Hdr_Shft_BitField_MaxValue ((1u << 5) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Pixcntforstat      : 27;  // Pixel counter for the stop of stat histogram
        unsigned int Gb_Hdr_Shft               : 5;   // reservedShift number for replacing division
    } reg;
} Reg_Hdr_2;
 
#define  Reg_Hdr_3_Gb_Hdr_Minstretchrange_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_3_Reserved_Hdr3_BitField_MaxValue ((1u << 9) - 1)
#define  Reg_Hdr_3_Gb_Hdr_Minfiltspd_BitField_MaxValue ((1u << 5) - 1)
#define  Reg_Hdr_3_Gb_Hdr_Binmedsdt_BitField_MaxValue ((1u << 8) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Minstretchrange    : 10;  // Threshold for restrict start point and end point of
                                                      // histogram. 
        unsigned int Reserved_Hdr3             : 9;   // reserved
        unsigned int Gb_Hdr_Minfiltspd         : 5;   // Minimal converge speed (frames) for inter-frame filter
        unsigned int Gb_Hdr_Binmedsdt          : 8;   // Start value of medium bin
    } reg;
} Reg_Hdr_3;
 
#define  Reg_Hdr_4_Gb_Hdr_Deltameanth_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_4_Gb_Hdr_Binmedhimax_BitField_MaxValue ((1u << 8) - 1)
#define  Reg_Hdr_4_Gb_Hdr_Yluthiwginit_BitField_MaxValue ((1u << 7) - 1)
#define  Reg_Hdr_4_Reserved_Hdr4_BitField_MaxValue ((1u << 7) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Deltameanth        : 10;  // The threshold for difference of Ymean
        unsigned int Gb_Hdr_Binmedhimax        : 8;   // Maximum value of medium bin of high light area
        unsigned int Gb_Hdr_Yluthiwginit       : 7;   // Initial value of weight of yLUTHi
        unsigned int Reserved_Hdr4             : 7;   // reserved
    } reg;
} Reg_Hdr_4;
 
#define  Reg_Hdr_5_Gb_Hdr_Meanchangeth_BitField_MaxValue ((1u << 28) - 1)
#define  Reg_Hdr_5_Reserved_Hdr5_BitField_MaxValue ((1u << 4) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Meanchangeth       : 28;  // The threshold for detecting scene change
        unsigned int Reserved_Hdr5             : 4;   // reserved
    } reg;
} Reg_Hdr_5;
 
#define  Reg_Hdr_6_Gb_Hdr_Pixlowratio_BitField_MaxValue ((1u << 26) - 1)
#define  Reg_Hdr_6_Reserved_Hdr6_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Pixlowratio        : 26;  // Ratio of pixels to find a bin start
        unsigned int Reserved_Hdr6             : 6;   // reserved
    } reg;
} Reg_Hdr_6;
 
#define  Reg_Hdr_7_Gb_Hdr_Pixhiratio_BitField_MaxValue ((1u << 26) - 1)
#define  Reg_Hdr_7_Reserved_Hdr7_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Pixhiratio         : 26;  // Ratio of pixels to find a bin end
        unsigned int Reserved_Hdr7             : 6;   // reserved
    } reg;
} Reg_Hdr_7;
 
#define  Reg_Hdr_8_Gb_Hdr_Blackratio_BitField_MaxValue ((1u << 26) - 1)
#define  Reg_Hdr_8_Reserved_Hdr8_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Blackratio         : 26;  // Ratio of pixels to find a black border 
        unsigned int Reserved_Hdr8             : 6;   // reserved
    } reg;
} Reg_Hdr_8;
 
#define  Reg_Hdr_9_Gb_Hdr_Noiseratio_BitField_MaxValue ((1u << 26) - 1)
#define  Reg_Hdr_9_Reserved_Hdr9_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Noiseratio         : 26;  // Ratio of dark noise which is darker than black border
        unsigned int Reserved_Hdr9             : 6;   // reserved
    } reg;
} Reg_Hdr_9;
 
#define  Reg_Hdr_Ylut_0_Gb_Hdr_Yluthi_00_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_0_Gb_Hdr_Yluthi_01_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_0_Gb_Hdr_Yluthi_02_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_0_Reserved_Hdr_Ylut0_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_00          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_01          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_02          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut0        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_0;
 
#define  Reg_Hdr_Ylut_1_Gb_Hdr_Yluthi_03_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_1_Gb_Hdr_Yluthi_04_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_1_Gb_Hdr_Yluthi_05_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_1_Reserved_Hdr_Ylut1_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_03          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_04          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_05          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut1        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_1;
 
#define  Reg_Hdr_Ylut_2_Gb_Hdr_Yluthi_06_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_2_Gb_Hdr_Yluthi_07_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_2_Gb_Hdr_Yluthi_08_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_2_Reserved_Hdr_Ylut2_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_06          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_07          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_08          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut2        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_2;
 
#define  Reg_Hdr_Ylut_3_Gb_Hdr_Yluthi_09_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_3_Gb_Hdr_Yluthi_0a_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_3_Gb_Hdr_Yluthi_0b_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_3_Reserved_Hdr_Ylut3_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_09          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_0a          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_0b          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut3        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_3;
 
#define  Reg_Hdr_Ylut_4_Gb_Hdr_Yluthi_0c_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_4_Gb_Hdr_Yluthi_0d_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_4_Gb_Hdr_Yluthi_0e_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_4_Reserved_Hdr_Ylut4_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_0c          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_0d          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_0e          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut4        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_4;
 
#define  Reg_Hdr_Ylut_5_Gb_Hdr_Yluthi_0f_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_5_Gb_Hdr_Yluthi_10_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_5_Gb_Hdr_Yluthi_11_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_5_Reserved_Hdr_Ylut5_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_0f          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_10          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_11          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut5        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_5;
 
#define  Reg_Hdr_Ylut_6_Gb_Hdr_Yluthi_12_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_6_Gb_Hdr_Yluthi_13_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_6_Gb_Hdr_Yluthi_14_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_6_Reserved_Hdr_Ylut6_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_12          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_13          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_14          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut6        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_6;
 
#define  Reg_Hdr_Ylut_7_Gb_Hdr_Yluthi_15_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_7_Gb_Hdr_Yluthi_16_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_7_Gb_Hdr_Yluthi_17_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_7_Reserved_Hdr_Ylut7_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_15          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_16          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_17          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut7        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_7;
 
#define  Reg_Hdr_Ylut_8_Gb_Hdr_Yluthi_18_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_8_Gb_Hdr_Yluthi_19_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_8_Gb_Hdr_Yluthi_1a_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_8_Reserved_Hdr_Ylut8_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_18          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_19          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_1a          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut8        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_8;
 
#define  Reg_Hdr_Ylut_9_Gb_Hdr_Yluthi_1b_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_9_Gb_Hdr_Yluthi_1c_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_9_Gb_Hdr_Yluthi_1d_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_9_Reserved_Hdr_Ylut9_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_1b          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_1c          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_1d          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Ylut9        : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_9;
 
#define  Reg_Hdr_Ylut_A_Gb_Hdr_Yluthi_1e_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_A_Gb_Hdr_Yluthi_1f_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_A_Reserved_Hdr_Yluta_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Yluthi_1e          : 10;  // Modulation curve for cdf only
        unsigned int Gb_Hdr_Yluthi_1f          : 10;  // Modulation curve for cdf only
        unsigned int Reserved_Hdr_Yluta        : 12;  // reserved
    } reg;
} Reg_Hdr_Ylut_A;
 
#define  Reg_Hdr_Ylut_10_Gb_Hdr_Ylutlow_00_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_10_Gb_Hdr_Ylutlow_01_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_10_Gb_Hdr_Ylutlow_02_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_10_Reserved_Hdr_Ylut10_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_00         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_01         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_02         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut10       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_10;
 
#define  Reg_Hdr_Ylut_11_Gb_Hdr_Ylutlow_03_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_11_Gb_Hdr_Ylutlow_04_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_11_Gb_Hdr_Ylutlow_05_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_11_Reserved_Hdr_Ylut11_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_03         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_04         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_05         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut11       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_11;
 
#define  Reg_Hdr_Ylut_12_Gb_Hdr_Ylutlow_06_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_12_Gb_Hdr_Ylutlow_07_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_12_Gb_Hdr_Ylutlow_08_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_12_Reserved_Hdr_Ylut12_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_06         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_07         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_08         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut12       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_12;
 
#define  Reg_Hdr_Ylut_13_Gb_Hdr_Ylutlow_09_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_13_Gb_Hdr_Ylutlow_0a_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_13_Gb_Hdr_Ylutlow_0b_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_13_Reserved_Hdr_Ylut13_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_09         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_0a         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_0b         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut13       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_13;
 
#define  Reg_Hdr_Ylut_14_Gb_Hdr_Ylutlow_0c_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_14_Gb_Hdr_Ylutlow_0d_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_14_Gb_Hdr_Ylutlow_0e_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_14_Reserved_Hdr_Ylut14_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_0c         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_0d         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_0e         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut14       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_14;
 
#define  Reg_Hdr_Ylut_15_Gb_Hdr_Ylutlow_0f_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_15_Gb_Hdr_Ylutlow_10_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_15_Gb_Hdr_Ylutlow_11_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_15_Reserved_Hdr_Ylut15_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_0f         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_10         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_11         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut15       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_15;
 
#define  Reg_Hdr_Ylut_16_Gb_Hdr_Ylutlow_12_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_16_Gb_Hdr_Ylutlow_13_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_16_Gb_Hdr_Ylutlow_14_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_16_Reserved_Hdr_Ylut16_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_12         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_13         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_14         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut16       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_16;
 
#define  Reg_Hdr_Ylut_17_Gb_Hdr_Ylutlow_15_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_17_Gb_Hdr_Ylutlow_16_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_17_Gb_Hdr_Ylutlow_17_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_17_Reserved_Hdr_Ylut17_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_15         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_16         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_17         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut17       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_17;
 
#define  Reg_Hdr_Ylut_18_Gb_Hdr_Ylutlow_18_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_18_Gb_Hdr_Ylutlow_19_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_18_Gb_Hdr_Ylutlow_1a_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_18_Reserved_Hdr_Ylut18_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_18         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_19         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_1a         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut18       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_18;
 
#define  Reg_Hdr_Ylut_19_Gb_Hdr_Ylutlow_1b_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_19_Gb_Hdr_Ylutlow_1c_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_19_Gb_Hdr_Ylutlow_1d_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_19_Reserved_Hdr_Ylut19_BitField_MaxValue ((1u << 2) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_1b         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_1c         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_1d         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut19       : 2;   // reserved
    } reg;
} Reg_Hdr_Ylut_19;
 
#define  Reg_Hdr_Ylut_1a_Gb_Hdr_Ylutlow_1e_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_1a_Gb_Hdr_Ylutlow_1f_BitField_MaxValue ((1u << 10) - 1)
#define  Reg_Hdr_Ylut_1a_Reserved_Hdr_Ylut1a_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Hdr_Ylutlow_1e         : 10;  // Modulation curve for cdf or user
        unsigned int Gb_Hdr_Ylutlow_1f         : 10;  // Modulation curve for cdf or user
        unsigned int Reserved_Hdr_Ylut1a       : 12;  // reserved
    } reg;
} Reg_Hdr_Ylut_1a;
 
#define  Reg_Sat_Set_Gb_Sat_Tbl_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Sat_Set_Reserved_Sat_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Sat_Tbl                : 20;  // Saturation adjustment LUT table(LUT-Y)
        unsigned int Reserved_Sat              : 12;  // reserved
    } reg;
} Reg_Sat_Set;
 
#define  Reg_Tm_Set_0_Gb_Tm_Idx_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Tm_Set_0_Reserved_Tm0_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Tm_Idx                 : 20;  // Tone mapping LUT index(LUT-X)
        unsigned int Reserved_Tm0              : 12;  // reserved
    } reg;
} Reg_Tm_Set_0;
 
#define  Reg_Tm_Set_1_Gb_Tm_Tbl_BitField_MaxValue ((1u << 26) - 1)
#define  Reg_Tm_Set_1_Reserved_Tm1_BitField_MaxValue ((1u << 6) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Tm_Tbl                 : 26;  // Tone mapping LUT table(LUT-X)
        unsigned int Reserved_Tm1              : 6;   // reserved
    } reg;
} Reg_Tm_Set_1;
 
#define  Reg_Tm_Set_2_Gb_Tm_Rec_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Tm_Set_2_Reserved_Tm2_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Tm_Rec                 : 20;  // reciprocal of adjacent LUT-X D-value
        unsigned int Reserved_Tm2              : 12;  // reserved
    } reg;
} Reg_Tm_Set_2;
 
#define  Reg_Tm_Set_3_Gb_Tm_En_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_Tm_Set_3_Reserved_Tm3_BitField_MaxValue ((1u << 31) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Gb_Tm_En                  : 1;   // Tone mapping enable
        unsigned int Reserved_Tm3              : 31;  // reserved
    } reg;
} Reg_Tm_Set_3;
 
typedef struct _Vpp_Global_regs
{
    Reg_Src_Base                     reg_Src_Base;
    Reg_Oth_Base                     reg_Oth_Base;
    Reg_Ref_Base                     reg_Ref_Base;
    Reg_Range_Set0                   reg_Range_Set0;
    Reg_Range_Set1                   reg_Range_Set1;
    Reg_Dst_Base                     reg_Dst_Base;
    Reg_Scl_Dst_Base_0               reg_Scl_Dst_Base_0;
    Reg_Scl_Dst_Base_1               reg_Scl_Dst_Base_1;
    Reg_Scl_Dst_Height               reg_Scl_Dst_Height;
    Reg_Bot_Base_0                   reg_Bot_Base_0;
    Reg_Bot_Base_1                   reg_Bot_Base_1;
    Reg_Bot_Base_2                   reg_Bot_Base_2;
    Reg_Hdr_Lut_Base                 reg_Hdr_Lut_Base;
    Reg_Hdr_Ysum_Base                reg_Hdr_Ysum_Base;
    Reg_Yv12_Base_U                  reg_Yv12_Base_U;
    Reg_Yv12_Base_V                  reg_Yv12_Base_V;
    Reg_Yv12_Base_Yuv0               reg_Yv12_Base_Yuv0;
    Reg_Scl_Para_Error               reg_Scl_Para_Error;
    Reg_Src_Sf_0                     reg_Src_Sf_0;
    Reg_Src_Sf_1                     reg_Src_Sf_1;
    Reg_Scl_Dst_Sf_1                 reg_Scl_Dst_Sf_1;
    Reg_Scl_Dst_Sf_2                 reg_Scl_Dst_Sf_2;
    Reg_Vpp_Ref_Sf                   reg_Vpp_Ref_Sf;
    Reg_Mode_Set                     reg_Mode_Set;
    Reg_Drv_Mp_Set                   reg_Drv_Mp_Set;
    Reg_Multipass_Set0               reg_Multipass_Set0;
    Reg_Multipass_Set1               reg_Multipass_Set1;
    Reg_Md5_Set0                     reg_Md5_Set0;
    Reg_Clip_L_R                     reg_Clip_L_R;
    Reg_Clip_T_B                     reg_Clip_T_B;
    Reg_Lbuf_Set0                    reg_Lbuf_Set0;
    Reg_Lbuf_Set0_1                  reg_Lbuf_Set0_1;
    Reg_Lbuf_Set0_2                  reg_Lbuf_Set0_2;
    Reg_Lbuf_Set0_3                  reg_Lbuf_Set0_3;
    Reg_Lbuf_Set1                    reg_Lbuf_Set1;
    Reg_Lbuf_Set2                    reg_Lbuf_Set2;
    Reg_Lbuf_Set3                    reg_Lbuf_Set3;
    Reg_Lbuf_Set4                    reg_Lbuf_Set4;
    Reg_Lbuf_Set5                    reg_Lbuf_Set5;
    Reg_Img_Related                  reg_Img_Related;
    Reg_Hslc_Set0                    reg_Hslc_Set0;
    Reg_Hslc_Set1                    reg_Hslc_Set1;
    Reg_Hslc_Set2                    reg_Hslc_Set2;
    Reg_Scl_Para_Sd                  reg_Scl_Para_Sd;
    Reg_Scl_Para_Ds                  reg_Scl_Para_Ds;
    Reg_Scl_0                        reg_Scl_0;
    Reg_Cscf_00_01                   reg_Cscf_00_01;
    Reg_Cscf_02_10                   reg_Cscf_02_10;
    Reg_Cscf_11_12                   reg_Cscf_11_12;
    Reg_Cscf_20_21                   reg_Cscf_20_21;
    Reg_Cscf_22                      reg_Cscf_22;
    Reg_Cscf_Off_00                  reg_Cscf_Off_00;
    Reg_Cscf_Off_01                  reg_Cscf_Off_01;
    Reg_Cscf_Off_02                  reg_Cscf_Off_02;
    Reg_Cscb_00_01                   reg_Cscb_00_01;
    Reg_Cscb_02_10                   reg_Cscb_02_10;
    Reg_Cscb_11_12                   reg_Cscb_11_12;
    Reg_Cscb_20_21                   reg_Cscb_20_21;
    Reg_Cscb_22                      reg_Cscb_22;
    Reg_Cscb_Off_00                  reg_Cscb_Off_00;
    Reg_Cscb_Off_01                  reg_Cscb_Off_01;
    Reg_Cscb_Off_02                  reg_Cscb_Off_02;
    Reg_Ld_Bld_Fixcolor              reg_Ld_Bld_Fixcolor;
    Reg_Cpt_0                        reg_Cpt_0;
    Reg_Cpt_1                        reg_Cpt_1;
    Reg_Cpt_2                        reg_Cpt_2;
    Reg_Mif_Arbiter_0                reg_Mif_Arbiter_0;
    Reg_Mif_Arbiter_1                reg_Mif_Arbiter_1;
    Reg_Mif_Arbiter_2                reg_Mif_Arbiter_2;
    Reg_Mif_Slot_Idx_0               reg_Mif_Slot_Idx_0;
    Reg_Mif_Slot_Idx_1               reg_Mif_Slot_Idx_1;
    Reg_Mif_Slot_Idx_2               reg_Mif_Slot_Idx_2;
    Reg_Mif_Slot_Idx_3               reg_Mif_Slot_Idx_3;
    Reg_Mif_Slot_Idx_4               reg_Mif_Slot_Idx_4;
    Reg_Mif_Pid_0                    reg_Mif_Pid_0;
    Reg_Mif_Pid_1                    reg_Mif_Pid_1;
    Reg_Di_0                         reg_Di_0;
    Reg_Di_1                         reg_Di_1;
    Reg_Di_2                         reg_Di_2;
    Reg_Di_3                         reg_Di_3;
    Reg_Di_4                         reg_Di_4;
    Reg_Di_5                         reg_Di_5;
    Reg_Di_6                         reg_Di_6;
    Reg_Di_7                         reg_Di_7;
    Reg_Di_8                         reg_Di_8;
    Reg_Di_9                         reg_Di_9;
    Reg_Di_A                         reg_Di_A;
    Reg_Di_B                         reg_Di_B;
    Reg_Di_C                         reg_Di_C;
    Reg_Di_D                         reg_Di_D;
    Reg_Di_E                         reg_Di_E;
    Reg_Vpp_Control_0                reg_Vpp_Control_0;
    Reg_Vpp_Control_3                reg_Vpp_Control_3;
    Reg_Vpp_Control_4                reg_Vpp_Control_4;
    Reg_Vpp_Control_5                reg_Vpp_Control_5;
    Reg_Vpp_Control_6                reg_Vpp_Control_6;
    Reg_Vpp_Control_9                reg_Vpp_Control_9;
    Reg_Vpp_Lbuf_0                   reg_Vpp_Lbuf_0;
    Reg_Vpp_Lbuf_1                   reg_Vpp_Lbuf_1;
    Reg_Vpp_Fd_Control_0             reg_Vpp_Fd_Control_0;
    Reg_Vpp_Fd_Control_1             reg_Vpp_Fd_Control_1;
    Reg_Vpp_Fd_Control_2             reg_Vpp_Fd_Control_2;
    Reg_Vpp_Fd_Control_3             reg_Vpp_Fd_Control_3;
    Reg_Vpp_Fd_Control_4             reg_Vpp_Fd_Control_4;
    Reg_Vpp_Fd_Control_5             reg_Vpp_Fd_Control_5;
    Reg_Vpp_Fd_Control_6             reg_Vpp_Fd_Control_6;
    Reg_Vpp_Fd_Control_7             reg_Vpp_Fd_Control_7;
    Reg_Cg_Ctrl                      reg_Cg_Ctrl;
    Reg_From_Opcode                  reg_From_Opcode;
    Reg_Cm_0                         reg_Cm_0;
    Reg_Cm_1                         reg_Cm_1[41];
    Reg_Ccm_0                        reg_Ccm_0;
    Reg_Ccm_1                        reg_Ccm_1;
    Reg_Ccm_3                        reg_Ccm_3[16];
    Reg_Ccm_4                        reg_Ccm_4[16];
    Reg_Ccm_5                        reg_Ccm_5;
    Reg_Ccm_6                        reg_Ccm_6[16];
    Reg_Ccm_7                        reg_Ccm_7;
    Reg_Ccm_8                        reg_Ccm_8;
    Reg_Ccm_9                        reg_Ccm_9;
    Reg_Ccm_A                        reg_Ccm_A;
    Reg_Ccm_B                        reg_Ccm_B[16];
    Reg_Ccm_C                        reg_Ccm_C;
    Reg_Ccm_D                        reg_Ccm_D;
    Reg_Cc_0                         reg_Cc_0;
    Reg_Cc_1                         reg_Cc_1;
    Reg_Cc_2                         reg_Cc_2;
    Reg_Cc_3                         reg_Cc_3;
    Reg_Cc_4                         reg_Cc_4;
    Reg_Hadj_0                       reg_Hadj_0;
    Reg_Hadj_1                       reg_Hadj_1;
    Reg_Hadj_2                       reg_Hadj_2;
    Reg_Hadj_3                       reg_Hadj_3;
    Reg_Sadj_0                       reg_Sadj_0;
    Reg_Sadj_1                       reg_Sadj_1;
    Reg_Sadj_2                       reg_Sadj_2;
    Reg_Sadj_3                       reg_Sadj_3;
    Reg_Sadj_4                       reg_Sadj_4;
    Reg_Sadj_5                       reg_Sadj_5;
    Reg_Sadj_6                       reg_Sadj_6;
    Reg_Sadj_7                       reg_Sadj_7;
    Reg_Sadj_8                       reg_Sadj_8;
    Reg_Hdr_0                        reg_Hdr_0;
    Reg_Hdr_1                        reg_Hdr_1;
    Reg_Hdr_2                        reg_Hdr_2;
    Reg_Hdr_3                        reg_Hdr_3;
    Reg_Hdr_4                        reg_Hdr_4;
    Reg_Hdr_5                        reg_Hdr_5;
    Reg_Hdr_6                        reg_Hdr_6;
    Reg_Hdr_7                        reg_Hdr_7;
    Reg_Hdr_8                        reg_Hdr_8;
    Reg_Hdr_9                        reg_Hdr_9;
    Reg_Hdr_Ylut_0                   reg_Hdr_Ylut_0;
    Reg_Hdr_Ylut_1                   reg_Hdr_Ylut_1;
    Reg_Hdr_Ylut_2                   reg_Hdr_Ylut_2;
    Reg_Hdr_Ylut_3                   reg_Hdr_Ylut_3;
    Reg_Hdr_Ylut_4                   reg_Hdr_Ylut_4;
    Reg_Hdr_Ylut_5                   reg_Hdr_Ylut_5;
    Reg_Hdr_Ylut_6                   reg_Hdr_Ylut_6;
    Reg_Hdr_Ylut_7                   reg_Hdr_Ylut_7;
    Reg_Hdr_Ylut_8                   reg_Hdr_Ylut_8;
    Reg_Hdr_Ylut_9                   reg_Hdr_Ylut_9;
    Reg_Hdr_Ylut_A                   reg_Hdr_Ylut_A;
    Reg_Hdr_Ylut_10                  reg_Hdr_Ylut_10;
    Reg_Hdr_Ylut_11                  reg_Hdr_Ylut_11;
    Reg_Hdr_Ylut_12                  reg_Hdr_Ylut_12;
    Reg_Hdr_Ylut_13                  reg_Hdr_Ylut_13;
    Reg_Hdr_Ylut_14                  reg_Hdr_Ylut_14;
    Reg_Hdr_Ylut_15                  reg_Hdr_Ylut_15;
    Reg_Hdr_Ylut_16                  reg_Hdr_Ylut_16;
    Reg_Hdr_Ylut_17                  reg_Hdr_Ylut_17;
    Reg_Hdr_Ylut_18                  reg_Hdr_Ylut_18;
    Reg_Hdr_Ylut_19                  reg_Hdr_Ylut_19;
    Reg_Hdr_Ylut_1a                  reg_Hdr_Ylut_1a;
    Reg_Sat_Set                      reg_Sat_Set[32];
    Reg_Tm_Set_0                     reg_Tm_Set_0[51];
    Reg_Tm_Set_1                     reg_Tm_Set_1[51];
    Reg_Tm_Set_2                     reg_Tm_Set_2[51];
    Reg_Tm_Set_3                     reg_Tm_Set_3;
} Vpp_Global_regs;

#endif
